/* DataObject.c generated by valac 0.12.0, the Vala compiler
 * generated from DataObject.vala, do not modify */

/* Copyright 2009-2011 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */
/**/
/* DataObject*/
/**/
/* Object IDs are incremented for each DataObject, and therefore may be used to compare*/
/* creation order.  This behavior may be relied upon elsewhere.  Object IDs may be recycled when*/
/* DataObjects are reconstituted by a proxy.*/
/**/
/* Ordinal IDs are supplied by DataCollections to record the ordering of the object being added*/
/* to the collection.  This value is primarily only used by DataCollection, but may be used*/
/* elsewhere to resolve ordering questions (including stabilizing a sort).*/
/**/
/* Have to inherit from Object due to ContainerSource and this bug:*/
/* https://bugzilla.gnome.org/show_bug.cgi?id=615904*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;
typedef struct _DataObjectPrivate DataObjectPrivate;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))

struct _DataObject {
	GObject parent_instance;
	DataObjectPrivate * priv;
};

struct _DataObjectClass {
	GObjectClass parent_class;
	void (*notify_altered) (DataObject* self, Alteration* alteration);
	void (*notify_membership_changed) (DataObject* self, DataCollection* collection);
	void (*notify_collection_property_set) (DataObject* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_collection_property_cleared) (DataObject* self, const gchar* name);
	gchar* (*get_name) (DataObject* self);
	gchar* (*to_string) (DataObject* self);
};

struct _DataObjectPrivate {
	gint64 object_id;
	DataCollection* member_of;
	gint64 ordinal;
};

typedef gboolean (*ValueEqualFunc) (GValue* a, GValue* b, void* user_data);

static gpointer data_object_parent_class = NULL;
static gint64 data_object_object_id_generator;
static gint64 data_object_object_id_generator = (gint64) 0;

GType data_object_get_type (void) G_GNUC_CONST;
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_alteration (GValue* value, gpointer v_object);
void value_take_alteration (GValue* value, gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
#define DATA_OBJECT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DATA_OBJECT, DataObjectPrivate))
enum  {
	DATA_OBJECT_DUMMY_PROPERTY
};
#define DATA_OBJECT_INVALID_OBJECT_ID ((gint64) (-1))
#define DATA_COLLECTION_INVALID_OBJECT_ORDINAL ((gint64) (-1))
DataObject* data_object_construct (GType object_type, gint64 object_id);
void data_object_notify_altered (DataObject* self, Alteration* alteration);
static void data_object_real_notify_altered (DataObject* self, Alteration* alteration);
void data_collection_internal_notify_altered (DataCollection* self, DataObject* object, Alteration* alteration);
void data_object_notify_membership_changed (DataObject* self, DataCollection* collection);
static void data_object_real_notify_membership_changed (DataObject* self, DataCollection* collection);
void data_object_notify_collection_property_set (DataObject* self, const gchar* name, GValue* old, GValue* val);
static void data_object_real_notify_collection_property_set (DataObject* self, const gchar* name, GValue* old, GValue* val);
void data_object_notify_collection_property_cleared (DataObject* self, const gchar* name);
static void data_object_real_notify_collection_property_cleared (DataObject* self, const gchar* name);
gchar* data_object_get_name (DataObject* self);
static gchar* data_object_real_get_name (DataObject* self);
gchar* data_object_to_string (DataObject* self);
static gchar* data_object_real_to_string (DataObject* self);
DataCollection* data_object_get_membership (DataObject* self);
gboolean data_object_has_membership (DataObject* self);
void data_object_internal_set_membership (DataObject* self, DataCollection* collection, gint64 ordinal);
void data_object_internal_set_ordinal (DataObject* self, gint64 ordinal);
void data_object_internal_clear_membership (DataObject* self);
gint64 data_object_internal_get_ordinal (DataObject* self);
gint64 data_object_get_object_id (DataObject* self);
GValue* data_object_get_collection_property (DataObject* self, const gchar* name, GValue* def);
static GValue* _g_value_dup (GValue* self);
GValue* data_collection_get_property (DataCollection* self, const gchar* name);
static void _vala_GValue_free (GValue* self);
void data_object_set_collection_property (DataObject* self, const gchar* name, GValue* val, ValueEqualFunc value_equals, void* value_equals_target);
void data_collection_set_property (DataCollection* self, const gchar* name, GValue* val, ValueEqualFunc value_equals, void* value_equals_target);
void data_object_clear_collection_property (DataObject* self, const gchar* name);
void data_collection_clear_property (DataCollection* self, const gchar* name);
static void data_object_finalize (GObject* obj);


DataObject* data_object_construct (GType object_type, gint64 object_id) {
	DataObject * self = NULL;
	gint64 _tmp0_ = 0LL;
	self = (DataObject*) g_object_new (object_type, NULL);
	if (object_id == DATA_OBJECT_INVALID_OBJECT_ID) {
		gint64 _tmp1_;
		_tmp1_ = data_object_object_id_generator;
		data_object_object_id_generator = _tmp1_ + 1;
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = object_id;
	}
	self->priv->object_id = _tmp0_;
	return self;
}


static void data_object_real_notify_altered (DataObject* self, Alteration* alteration) {
	g_return_if_fail (IS_DATA_OBJECT (self));
	g_return_if_fail (IS_ALTERATION (alteration));
	if (self->priv->member_of != NULL) {
		data_collection_internal_notify_altered (self->priv->member_of, self, alteration);
	}
}


void data_object_notify_altered (DataObject* self, Alteration* alteration) {
	DATA_OBJECT_GET_CLASS (self)->notify_altered (self, alteration);
}


static void data_object_real_notify_membership_changed (DataObject* self, DataCollection* collection) {
	g_return_if_fail (IS_DATA_OBJECT (self));
	g_return_if_fail ((collection == NULL) || IS_DATA_COLLECTION (collection));
}


void data_object_notify_membership_changed (DataObject* self, DataCollection* collection) {
	DATA_OBJECT_GET_CLASS (self)->notify_membership_changed (self, collection);
}


static void data_object_real_notify_collection_property_set (DataObject* self, const gchar* name, GValue* old, GValue* val) {
	g_return_if_fail (IS_DATA_OBJECT (self));
	g_return_if_fail (name != NULL);
}


void data_object_notify_collection_property_set (DataObject* self, const gchar* name, GValue* old, GValue* val) {
	DATA_OBJECT_GET_CLASS (self)->notify_collection_property_set (self, name, old, val);
}


static void data_object_real_notify_collection_property_cleared (DataObject* self, const gchar* name) {
	g_return_if_fail (IS_DATA_OBJECT (self));
	g_return_if_fail (name != NULL);
}


void data_object_notify_collection_property_cleared (DataObject* self, const gchar* name) {
	DATA_OBJECT_GET_CLASS (self)->notify_collection_property_cleared (self, name);
}


static gchar* data_object_real_get_name (DataObject* self) {
	g_return_val_if_fail (IS_DATA_OBJECT (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `data_object_get_name'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


gchar* data_object_get_name (DataObject* self) {
	return DATA_OBJECT_GET_CLASS (self)->get_name (self);
}


static gchar* data_object_real_to_string (DataObject* self) {
	g_return_val_if_fail (IS_DATA_OBJECT (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `data_object_to_string'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


gchar* data_object_to_string (DataObject* self) {
	return DATA_OBJECT_GET_CLASS (self)->to_string (self);
}


static gpointer _data_collection_ref0 (gpointer self) {
	return self ? data_collection_ref (self) : NULL;
}


DataCollection* data_object_get_membership (DataObject* self) {
	DataCollection* result = NULL;
	DataCollection* _tmp0_;
	g_return_val_if_fail (IS_DATA_OBJECT (self), NULL);
	_tmp0_ = _data_collection_ref0 (self->priv->member_of);
	result = _tmp0_;
	return result;
}


gboolean data_object_has_membership (DataObject* self) {
	gboolean result = FALSE;
	g_return_val_if_fail (IS_DATA_OBJECT (self), FALSE);
	result = self->priv->member_of != NULL;
	return result;
}


void data_object_internal_set_membership (DataObject* self, DataCollection* collection, gint64 ordinal) {
	DataCollection* _tmp0_;
	g_return_if_fail (IS_DATA_OBJECT (self));
	g_return_if_fail (IS_DATA_COLLECTION (collection));
	g_assert (self->priv->member_of == NULL);
	_tmp0_ = _data_collection_ref0 (collection);
	_data_collection_unref0 (self->priv->member_of);
	self->priv->member_of = _tmp0_;
	self->priv->ordinal = ordinal;
}


void data_object_internal_set_ordinal (DataObject* self, gint64 ordinal) {
	g_return_if_fail (IS_DATA_OBJECT (self));
	g_assert (self->priv->member_of == NULL);
	self->priv->ordinal = ordinal;
}


void data_object_internal_clear_membership (DataObject* self) {
	g_return_if_fail (IS_DATA_OBJECT (self));
	_data_collection_unref0 (self->priv->member_of);
	self->priv->member_of = NULL;
	self->priv->ordinal = DATA_COLLECTION_INVALID_OBJECT_ORDINAL;
}


inline gint64 data_object_internal_get_ordinal (DataObject* self) {
	gint64 result = 0LL;
	g_return_val_if_fail (IS_DATA_OBJECT (self), 0LL);
	result = self->priv->ordinal;
	return result;
}


inline gint64 data_object_get_object_id (DataObject* self) {
	gint64 result = 0LL;
	g_return_val_if_fail (IS_DATA_OBJECT (self), 0LL);
	result = self->priv->object_id;
	return result;
}


static GValue* _g_value_dup (GValue* self) {
	return g_boxed_copy (G_TYPE_VALUE, self);
}


static gpointer __g_value_dup0 (gpointer self) {
	return self ? _g_value_dup (self) : NULL;
}


static void _vala_GValue_free (GValue* self) {
	g_value_unset (self);
	g_free (self);
}


GValue* data_object_get_collection_property (DataObject* self, const gchar* name, GValue* def) {
	GValue* result = NULL;
	GValue* _tmp1_ = NULL;
	GValue* _result_;
	GValue* _tmp2_ = NULL;
	GValue* _tmp3_;
	g_return_val_if_fail (IS_DATA_OBJECT (self), NULL);
	g_return_val_if_fail (name != NULL, NULL);
	if (self->priv->member_of == NULL) {
		GValue* _tmp0_;
		_tmp0_ = __g_value_dup0 (def);
		result = _tmp0_;
		return result;
	}
	_tmp1_ = data_collection_get_property (self->priv->member_of, name);
	_result_ = _tmp1_;
	if (_result_ != NULL) {
		_tmp2_ = _result_;
	} else {
		_tmp2_ = def;
	}
	_tmp3_ = __g_value_dup0 (_tmp2_);
	result = _tmp3_;
	__vala_GValue_free0 (_result_);
	return result;
}


void data_object_set_collection_property (DataObject* self, const gchar* name, GValue* val, ValueEqualFunc value_equals, void* value_equals_target) {
	g_return_if_fail (IS_DATA_OBJECT (self));
	g_return_if_fail (name != NULL);
	if (self->priv->member_of != NULL) {
		data_collection_set_property (self->priv->member_of, name, val, value_equals, value_equals_target);
	}
}


void data_object_clear_collection_property (DataObject* self, const gchar* name) {
	g_return_if_fail (IS_DATA_OBJECT (self));
	g_return_if_fail (name != NULL);
	if (self->priv->member_of != NULL) {
		data_collection_clear_property (self->priv->member_of, name);
	}
}


static void data_object_class_init (DataObjectClass * klass) {
	data_object_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DataObjectPrivate));
	DATA_OBJECT_CLASS (klass)->notify_altered = data_object_real_notify_altered;
	DATA_OBJECT_CLASS (klass)->notify_membership_changed = data_object_real_notify_membership_changed;
	DATA_OBJECT_CLASS (klass)->notify_collection_property_set = data_object_real_notify_collection_property_set;
	DATA_OBJECT_CLASS (klass)->notify_collection_property_cleared = data_object_real_notify_collection_property_cleared;
	DATA_OBJECT_CLASS (klass)->get_name = data_object_real_get_name;
	DATA_OBJECT_CLASS (klass)->to_string = data_object_real_to_string;
	G_OBJECT_CLASS (klass)->finalize = data_object_finalize;
}


static void data_object_instance_init (DataObject * self) {
	self->priv = DATA_OBJECT_GET_PRIVATE (self);
	self->priv->object_id = DATA_OBJECT_INVALID_OBJECT_ID;
	self->priv->member_of = NULL;
	self->priv->ordinal = DATA_COLLECTION_INVALID_OBJECT_ORDINAL;
}


static void data_object_finalize (GObject* obj) {
	DataObject * self;
	self = DATA_OBJECT (obj);
	_data_collection_unref0 (self->priv->member_of);
	G_OBJECT_CLASS (data_object_parent_class)->finalize (obj);
}


GType data_object_get_type (void) {
	static volatile gsize data_object_type_id__volatile = 0;
	if (g_once_init_enter (&data_object_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DataObjectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_object_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DataObject), 0, (GInstanceInitFunc) data_object_instance_init, NULL };
		GType data_object_type_id;
		data_object_type_id = g_type_register_static (G_TYPE_OBJECT, "DataObject", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&data_object_type_id__volatile, data_object_type_id);
	}
	return data_object_type_id__volatile;
}



