/* FaceTable.c generated by valac 0.12.0, the Vala compiler
 * generated from FaceTable.vala, do not modify */

/* Copyright 2011 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <sqlite3.h>
#include <gee.h>


#define TYPE_FACE_ID (face_id_get_type ())
typedef struct _FaceID FaceID;

#define TYPE_FACE_ROW (face_row_get_type ())
typedef struct _FaceRow FaceRow;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;

#define TYPE_FACE_TABLE (face_table_get_type ())
#define FACE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FACE_TABLE, FaceTable))
#define FACE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FACE_TABLE, FaceTableClass))
#define IS_FACE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FACE_TABLE))
#define IS_FACE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FACE_TABLE))
#define FACE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FACE_TABLE, FaceTableClass))

typedef struct _FaceTable FaceTable;
typedef struct _FaceTableClass FaceTableClass;
typedef struct _FaceTablePrivate FaceTablePrivate;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _FaceID {
	gint64 id;
};

struct _FaceRow {
	FaceID face_id;
	gchar* name;
	time_t time_created;
};

struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _FaceTable {
	DatabaseTable parent_instance;
	FaceTablePrivate * priv;
};

struct _FaceTableClass {
	DatabaseTableClass parent_class;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()

static gpointer face_table_parent_class = NULL;
static FaceTable* face_table_instance;
static FaceTable* face_table_instance = NULL;
extern sqlite3* database_table_db;

GType face_id_get_type (void) G_GNUC_CONST;
FaceID* face_id_dup (const FaceID* self);
void face_id_free (FaceID* self);
#define FACE_ID_INVALID ((gint64) (-1))
void face_id_init (FaceID *self, gint64 id);
gboolean face_id_is_invalid (FaceID *self);
gboolean face_id_is_valid (FaceID *self);
GType face_row_get_type (void) G_GNUC_CONST;
FaceRow* face_row_dup (const FaceRow* self);
void face_row_free (FaceRow* self);
void face_row_copy (const FaceRow* self, FaceRow* dest);
void face_row_destroy (FaceRow* self);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_database_table (GValue* value, gpointer v_object);
void value_take_database_table (GValue* value, gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType face_table_get_type (void) G_GNUC_CONST;
enum  {
	FACE_TABLE_DUMMY_PROPERTY
};
static FaceTable* face_table_new (void);
static FaceTable* face_table_construct (GType object_type);
DatabaseTable* database_table_construct (GType object_type);
void database_table_set_table_name (DatabaseTable* self, const gchar* table_name);
void database_table_fatal (const gchar* op, gint res);
FaceTable* face_table_get_instance (void);
GQuark database_error_quark (void);
void face_table_add (FaceTable* self, const gchar* name, FaceRow* result, GError** error);
gulong now_sec (void);
void database_table_throw_error (const gchar* method, gint res, GError** error);
void face_table_create_from_row (FaceTable* self, FaceRow* row, FaceID* result, GError** error);
void face_table_remove (FaceTable* self, FaceID* face_id, GError** error);
void database_table_delete_by_id (DatabaseTable* self, gint64 id, GError** error);
gchar* face_table_get_name (FaceTable* self, FaceID* face_id, GError** error);
gboolean database_table_select_by_id (DatabaseTable* self, gint64 id, const gchar* columns, sqlite3_stmt** stmt);
FaceRow* face_table_get_row (FaceTable* self, FaceID* face_id, GError** error);
GeeList* face_table_get_all_rows (FaceTable* self, GError** error);
void face_table_rename (FaceTable* self, FaceID* face_id, const gchar* new_name, GError** error);
void database_table_update_text_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, const gchar* text, GError** error);
static void face_table_finalize (DatabaseTable* obj);


void face_id_init (FaceID *self, gint64 id) {
	memset (self, 0, sizeof (FaceID));
	(*self).id = id;
}


gboolean face_id_is_invalid (FaceID *self) {
	gboolean result = FALSE;
	result = (*self).id == FACE_ID_INVALID;
	return result;
}


gboolean face_id_is_valid (FaceID *self) {
	gboolean result = FALSE;
	result = (*self).id != FACE_ID_INVALID;
	return result;
}


FaceID* face_id_dup (const FaceID* self) {
	FaceID* dup;
	dup = g_new0 (FaceID, 1);
	memcpy (dup, self, sizeof (FaceID));
	return dup;
}


void face_id_free (FaceID* self) {
	g_free (self);
}


GType face_id_get_type (void) {
	static volatile gsize face_id_type_id__volatile = 0;
	if (g_once_init_enter (&face_id_type_id__volatile)) {
		GType face_id_type_id;
		face_id_type_id = g_boxed_type_register_static ("FaceID", (GBoxedCopyFunc) face_id_dup, (GBoxedFreeFunc) face_id_free);
		g_once_init_leave (&face_id_type_id__volatile, face_id_type_id);
	}
	return face_id_type_id__volatile;
}


void face_row_copy (const FaceRow* self, FaceRow* dest) {
	dest->face_id = self->face_id;
	dest->name = g_strdup (self->name);
	dest->time_created = self->time_created;
}


void face_row_destroy (FaceRow* self) {
	_g_free0 ((*self).name);
}


FaceRow* face_row_dup (const FaceRow* self) {
	FaceRow* dup;
	dup = g_new0 (FaceRow, 1);
	face_row_copy (self, dup);
	return dup;
}


void face_row_free (FaceRow* self) {
	face_row_destroy (self);
	g_free (self);
}


GType face_row_get_type (void) {
	static volatile gsize face_row_type_id__volatile = 0;
	if (g_once_init_enter (&face_row_type_id__volatile)) {
		GType face_row_type_id;
		face_row_type_id = g_boxed_type_register_static ("FaceRow", (GBoxedCopyFunc) face_row_dup, (GBoxedFreeFunc) face_row_free);
		g_once_init_leave (&face_row_type_id__volatile, face_row_type_id);
	}
	return face_row_type_id__volatile;
}


static FaceTable* face_table_construct (GType object_type) {
	FaceTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gint _tmp2_;
	self = (FaceTable*) database_table_construct (object_type);
	database_table_set_table_name (DATABASE_TABLE (self), "FaceTable");
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "CREATE TABLE IF NOT EXISTS " "FaceTable " "(" "id INTEGER NOT NULL PRIMARY KEY, " "name TEXT NOT NULL, " "time_created TIMESTAMP" ")", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = sqlite3_step (stmt);
	res = _tmp2_;
	if (res != SQLITE_DONE) {
		database_table_fatal ("create FaceTable", res);
	}
	_sqlite3_finalize0 (stmt);
	return self;
}


static FaceTable* face_table_new (void) {
	return face_table_construct (TYPE_FACE_TABLE);
}


static gpointer _database_table_ref0 (gpointer self) {
	return self ? database_table_ref (self) : NULL;
}


FaceTable* face_table_get_instance (void) {
	FaceTable* result = NULL;
	FaceTable* _tmp1_;
	if (face_table_instance == NULL) {
		FaceTable* _tmp0_ = NULL;
		_tmp0_ = face_table_new ();
		_database_table_unref0 (face_table_instance);
		face_table_instance = _tmp0_;
	}
	_tmp1_ = _database_table_ref0 (face_table_instance);
	result = _tmp1_;
	return result;
}


void face_table_add (FaceTable* self, const gchar* name, FaceRow* result, GError** error) {
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gulong _tmp2_;
	time_t time_created;
	gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	FaceRow row = {0};
	gint64 _tmp7_;
	FaceID _tmp8_ = {0};
	FaceID _tmp9_ = {0};
	gchar* _tmp10_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_FACE_TABLE (self));
	g_return_if_fail (name != NULL);
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "INSERT INTO FaceTable (name, time_created) VALUES (?, ?)", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = now_sec ();
	time_created = (time_t) _tmp2_;
	_tmp3_ = g_strdup (name);
	_tmp4_ = sqlite3_bind_text (stmt, 1, _tmp3_, -1, g_free);
	res = _tmp4_;
	g_assert (res == SQLITE_OK);
	_tmp5_ = sqlite3_bind_int64 (stmt, 2, (gint64) time_created);
	res = _tmp5_;
	g_assert (res == SQLITE_OK);
	_tmp6_ = sqlite3_step (stmt);
	res = _tmp6_;
	if (res != SQLITE_DONE) {
		database_table_throw_error ("FaceTable.add", res, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_sqlite3_finalize0 (stmt);
				return;
			} else {
				_sqlite3_finalize0 (stmt);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	memset (&row, 0, sizeof (FaceRow));
	_tmp7_ = sqlite3_last_insert_rowid (database_table_db);
	face_id_init (&_tmp8_, _tmp7_);
	_tmp9_ = _tmp8_;
	row.face_id = _tmp9_;
	_tmp10_ = g_strdup (name);
	_g_free0 (row.name);
	row.name = _tmp10_;
	row.time_created = time_created;
	*result = row;
	_sqlite3_finalize0 (stmt);
	return;
}


void face_table_create_from_row (FaceTable* self, FaceRow* row, FaceID* result, GError** error) {
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint64 _tmp6_;
	FaceID _tmp7_ = {0};
	FaceID _tmp8_ = {0};
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_FACE_TABLE (self));
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "INSERT INTO FaceTable (name, time_created) VALUES (?, ?)", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = g_strdup ((*row).name);
	_tmp3_ = sqlite3_bind_text (stmt, 1, _tmp2_, -1, g_free);
	res = _tmp3_;
	g_assert (res == SQLITE_OK);
	_tmp4_ = sqlite3_bind_int64 (stmt, 2, (gint64) (*row).time_created);
	res = _tmp4_;
	g_assert (res == SQLITE_OK);
	_tmp5_ = sqlite3_step (stmt);
	res = _tmp5_;
	if (res != SQLITE_DONE) {
		database_table_throw_error ("FaceTable.create_from_row", res, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_sqlite3_finalize0 (stmt);
				return;
			} else {
				_sqlite3_finalize0 (stmt);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	_tmp6_ = sqlite3_last_insert_rowid (database_table_db);
	face_id_init (&_tmp7_, _tmp6_);
	_tmp8_ = _tmp7_;
	*result = _tmp8_;
	_sqlite3_finalize0 (stmt);
	return;
}


void face_table_remove (FaceTable* self, FaceID* face_id, GError** error) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_FACE_TABLE (self));
	database_table_delete_by_id (DATABASE_TABLE (self), (*face_id).id, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


gchar* face_table_get_name (FaceTable* self, FaceID* face_id, GError** error) {
	gchar* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gboolean _tmp1_;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	g_return_val_if_fail (IS_FACE_TABLE (self), NULL);
	_tmp1_ = database_table_select_by_id (DATABASE_TABLE (self), (*face_id).id, "name", &_tmp0_);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	if (!_tmp1_) {
		result = NULL;
		_sqlite3_finalize0 (stmt);
		return result;
	}
	_tmp2_ = sqlite3_column_text (stmt, 0);
	_tmp3_ = g_strdup (_tmp2_);
	result = _tmp3_;
	_sqlite3_finalize0 (stmt);
	return result;
}


static gpointer _face_row_dup0 (gpointer self) {
	return self ? face_row_dup (self) : NULL;
}


FaceRow* face_table_get_row (FaceTable* self, FaceID* face_id, GError** error) {
	FaceRow* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gint _tmp2_;
	gint _tmp3_;
	FaceRow row = {0};
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	gint64 _tmp6_;
	FaceRow _tmp7_;
	FaceRow* _tmp8_;
	FaceRow* _tmp9_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_FACE_TABLE (self), NULL);
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "SELECT name, time_created FROM FaceTable WHERE id=?", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = sqlite3_bind_int64 (stmt, 1, (*face_id).id);
	res = _tmp2_;
	g_assert (res == SQLITE_OK);
	_tmp3_ = sqlite3_step (stmt);
	res = _tmp3_;
	if (res == SQLITE_DONE) {
		result = NULL;
		_sqlite3_finalize0 (stmt);
		return result;
	} else {
		if (res != SQLITE_ROW) {
			database_table_throw_error ("FaceTable.get_row", res, &_inner_error_);
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == DATABASE_ERROR) {
					g_propagate_error (error, _inner_error_);
					_sqlite3_finalize0 (stmt);
					return NULL;
				} else {
					_sqlite3_finalize0 (stmt);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
			}
		}
	}
	memset (&row, 0, sizeof (FaceRow));
	row.face_id = *face_id;
	_tmp4_ = sqlite3_column_text (stmt, 0);
	_tmp5_ = g_strdup (_tmp4_);
	_g_free0 (row.name);
	row.name = _tmp5_;
	_tmp6_ = sqlite3_column_int64 (stmt, 1);
	row.time_created = (time_t) _tmp6_;
	_tmp7_ = row;
	_tmp8_ = _face_row_dup0 (&_tmp7_);
	_tmp9_ = _tmp8_;
	face_row_destroy (&_tmp7_);
	result = _tmp9_;
	_sqlite3_finalize0 (stmt);
	return result;
}


GeeList* face_table_get_all_rows (FaceTable* self, GError** error) {
	GeeList* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	GeeArrayList* _tmp2_ = NULL;
	GeeList* rows;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_FACE_TABLE (self), NULL);
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "SELECT id, name, time_created FROM FaceTable", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = gee_array_list_new (TYPE_FACE_ROW, (GBoxedCopyFunc) face_row_dup, face_row_free, NULL);
	rows = GEE_LIST (_tmp2_);
	{
		gboolean _tmp3_;
		_tmp3_ = TRUE;
		while (TRUE) {
			gint _tmp4_;
			FaceRow row = {0};
			gint64 _tmp5_;
			FaceID _tmp6_ = {0};
			FaceID _tmp7_ = {0};
			const gchar* _tmp8_ = NULL;
			gchar* _tmp9_;
			gint64 _tmp10_;
			if (!_tmp3_) {
			}
			_tmp3_ = FALSE;
			_tmp4_ = sqlite3_step (stmt);
			res = _tmp4_;
			if (res == SQLITE_DONE) {
				break;
			} else {
				if (res != SQLITE_ROW) {
					database_table_throw_error ("FaceTable.get_all_rows", res, &_inner_error_);
					if (_inner_error_ != NULL) {
						if (_inner_error_->domain == DATABASE_ERROR) {
							g_propagate_error (error, _inner_error_);
							_g_object_unref0 (rows);
							_sqlite3_finalize0 (stmt);
							return NULL;
						} else {
							_g_object_unref0 (rows);
							_sqlite3_finalize0 (stmt);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return NULL;
						}
					}
				}
			}
			memset (&row, 0, sizeof (FaceRow));
			_tmp5_ = sqlite3_column_int64 (stmt, 0);
			face_id_init (&_tmp6_, _tmp5_);
			_tmp7_ = _tmp6_;
			row.face_id = _tmp7_;
			_tmp8_ = sqlite3_column_text (stmt, 1);
			_tmp9_ = g_strdup (_tmp8_);
			_g_free0 (row.name);
			row.name = _tmp9_;
			_tmp10_ = sqlite3_column_int64 (stmt, 2);
			row.time_created = (time_t) _tmp10_;
			gee_collection_add (GEE_COLLECTION (rows), &row);
			face_row_destroy (&row);
		}
	}
	result = rows;
	_sqlite3_finalize0 (stmt);
	return result;
}


void face_table_rename (FaceTable* self, FaceID* face_id, const gchar* new_name, GError** error) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_FACE_TABLE (self));
	g_return_if_fail (new_name != NULL);
	database_table_update_text_by_id_2 (DATABASE_TABLE (self), (*face_id).id, "name", new_name, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void face_table_class_init (FaceTableClass * klass) {
	face_table_parent_class = g_type_class_peek_parent (klass);
	DATABASE_TABLE_CLASS (klass)->finalize = face_table_finalize;
}


static void face_table_instance_init (FaceTable * self) {
}


static void face_table_finalize (DatabaseTable* obj) {
	FaceTable * self;
	self = FACE_TABLE (obj);
	DATABASE_TABLE_CLASS (face_table_parent_class)->finalize (obj);
}


GType face_table_get_type (void) {
	static volatile gsize face_table_type_id__volatile = 0;
	if (g_once_init_enter (&face_table_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FaceTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) face_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FaceTable), 0, (GInstanceInitFunc) face_table_instance_init, NULL };
		GType face_table_type_id;
		face_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "FaceTable", &g_define_type_info, 0);
		g_once_init_leave (&face_table_type_id__volatile, face_table_type_id);
	}
	return face_table_type_id__volatile;
}



