/* PhotoMetadata.c generated by valac 0.12.0, the Vala compiler
 * generated from PhotoMetadata.vala, do not modify */

/* Copyright 2010-2011 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */
/**/
/* PhotoMetadata*/
/**/
/* PhotoMetadata is a wrapper class around gexiv2.  The reasoning for this is (a) to facilitiate*/
/* interface changes to meet Shotwell's requirements without needing modifications of the library*/
/* itself, and (b) some requirements for this class (i.e. obtaining raw metadata) is not available*/
/* in gexiv2, and so must be done by hand.*/
/**/
/* Although it's perceived that Exiv2 will remain Shotwell's metadata library of choice, this*/
/* may change in the future, and so this wrapper helps with that as well.*/
/**/
/* There is no expectation of thread-safety in this class (yet).*/
/**/
/* Tags come from Exiv2's naming scheme:*/
/* http://www.exiv2.org/metadata.html*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <gio/gio.h>
#include <gexiv2/gexiv2.h>
#include <libexif/exif-data.h>
#include <gee.h>
#include <libexif/exif-mem.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>


#define TYPE_METADATA_DOMAIN (metadata_domain_get_type ())

#define TYPE_HIERARCHICAL_KEYWORD_FIELD (hierarchical_keyword_field_get_type ())
typedef struct _HierarchicalKeywordField HierarchicalKeywordField;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_PHOTO_PREVIEW (photo_preview_get_type ())
#define PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_PREVIEW, PhotoPreview))
#define PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))
#define IS_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_PREVIEW))
#define IS_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_PREVIEW))
#define PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))

typedef struct _PhotoPreview PhotoPreview;
typedef struct _PhotoPreviewClass PhotoPreviewClass;
typedef struct _PhotoPreviewPrivate PhotoPreviewPrivate;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecPhotoPreview ParamSpecPhotoPreview;

#define TYPE_MEDIA_METADATA (media_metadata_get_type ())
#define MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_METADATA, MediaMetadata))
#define MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_METADATA, MediaMetadataClass))
#define IS_MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_METADATA))
#define IS_MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_METADATA))
#define MEDIA_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_METADATA, MediaMetadataClass))

typedef struct _MediaMetadata MediaMetadata;
typedef struct _MediaMetadataClass MediaMetadataClass;
typedef struct _MediaMetadataPrivate MediaMetadataPrivate;

#define TYPE_METADATA_DATE_TIME (metadata_date_time_get_type ())
#define METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTime))
#define METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))
#define IS_METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_DATE_TIME))
#define IS_METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_DATE_TIME))
#define METADATA_DATE_TIME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))

typedef struct _MetadataDateTime MetadataDateTime;
typedef struct _MetadataDateTimeClass MetadataDateTimeClass;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;
typedef struct _PhotoMetadataPrivate PhotoMetadataPrivate;

#define PHOTO_METADATA_TYPE_SET_OPTION (photo_metadata_set_option_get_type ())
#define _gexiv2_metadata_free0(var) ((var == NULL) ? NULL : (var = (gexiv2_metadata_free (var), NULL)))
#define _exif_data_unref0(var) ((var == NULL) ? NULL : (var = (exif_data_unref (var), NULL)))

#define TYPE_PREPARE_INPUT_TEXT_OPTIONS (prepare_input_text_options_get_type ())
typedef struct _Block1Data Block1Data;
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
typedef struct _Block3Data Block3Data;

#define TYPE_METADATA_RATIONAL (metadata_rational_get_type ())
typedef struct _MetadataRational MetadataRational;
typedef struct _Block4Data Block4Data;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))
typedef struct _Block5Data Block5Data;
#define _exif_mem_unref0(var) ((var == NULL) ? NULL : (var = (exif_mem_unref (var), NULL)))

#define PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW (photo_metadata_internal_photo_preview_get_type ())
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreview))
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreviewClass))
#define PHOTO_METADATA_IS_INTERNAL_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW))
#define PHOTO_METADATA_IS_INTERNAL_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW))
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreviewClass))

typedef struct _PhotoMetadataInternalPhotoPreview PhotoMetadataInternalPhotoPreview;
typedef struct _PhotoMetadataInternalPhotoPreviewClass PhotoMetadataInternalPhotoPreviewClass;

#define TYPE_HIERARCHICAL_TAG_INDEX (hierarchical_tag_index_get_type ())
#define HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndex))
#define HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))
#define IS_HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HIERARCHICAL_TAG_INDEX))
#define IS_HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HIERARCHICAL_TAG_INDEX))
#define HIERARCHICAL_TAG_INDEX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))

typedef struct _HierarchicalTagIndex HierarchicalTagIndex;
typedef struct _HierarchicalTagIndexClass HierarchicalTagIndexClass;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _hierarchical_tag_index_unref0(var) ((var == NULL) ? NULL : (var = (hierarchical_tag_index_unref (var), NULL)))

#define TYPE_ORIENTATION (orientation_get_type ())

#define TYPE_RATING (rating_get_type ())
typedef struct _PhotoMetadataInternalPhotoPreviewPrivate PhotoMetadataInternalPhotoPreviewPrivate;
#define _gexiv2_preview_image_free0(var) ((var == NULL) ? NULL : (var = (gexiv2_preview_image_free (var), NULL)))

typedef enum  {
	METADATA_DOMAIN_UNKNOWN,
	METADATA_DOMAIN_EXIF,
	METADATA_DOMAIN_XMP,
	METADATA_DOMAIN_IPTC
} MetadataDomain;

struct _HierarchicalKeywordField {
	gchar* field_name;
	gchar* path_separator;
	gboolean wants_leading_separator;
	gboolean is_writeable;
};

struct _PhotoPreview {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoPreviewPrivate * priv;
};

struct _PhotoPreviewClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoPreview *self);
	guint8* (*flatten) (PhotoPreview* self, int* result_length1, GError** error);
	GdkPixbuf* (*get_pixbuf) (PhotoPreview* self, GError** error);
};

struct _Dimensions {
	gint width;
	gint height;
};

struct _PhotoPreviewPrivate {
	gchar* name;
	Dimensions dimensions;
	guint32 size;
	gchar* mime_type;
	gchar* extension;
};

struct _ParamSpecPhotoPreview {
	GParamSpec parent_instance;
};

struct _MediaMetadata {
	GTypeInstance parent_instance;
	volatile int ref_count;
	MediaMetadataPrivate * priv;
};

struct _MediaMetadataClass {
	GTypeClass parent_class;
	void (*finalize) (MediaMetadata *self);
	void (*read_from_file) (MediaMetadata* self, GFile* file, GError** error);
	MetadataDateTime* (*get_creation_date_time) (MediaMetadata* self);
	gchar* (*get_title) (MediaMetadata* self);
};

struct _PhotoMetadata {
	MediaMetadata parent_instance;
	PhotoMetadataPrivate * priv;
};

struct _PhotoMetadataClass {
	MediaMetadataClass parent_class;
};

struct _PhotoMetadataPrivate {
	GExiv2Metadata* exiv2;
	ExifData* exif;
	gchar* source_name;
};

typedef enum  {
	PHOTO_METADATA_SET_OPTION_ALL_DOMAINS,
	PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT,
	PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN
} PhotoMetadataSetOption;

typedef enum  {
	PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL = 1 << 0,
	PREPARE_INPUT_TEXT_OPTIONS_VALIDATE = 1 << 1,
	PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL = 1 << 2,
	PREPARE_INPUT_TEXT_OPTIONS_STRIP = 1 << 3,
	PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF = 1 << 4,
	PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE = 1 << 5,
	PREPARE_INPUT_TEXT_OPTIONS_DEFAULT = ((((PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL | PREPARE_INPUT_TEXT_OPTIONS_VALIDATE) | PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL) | PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF) | PREPARE_INPUT_TEXT_OPTIONS_STRIP) | PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE
} PrepareInputTextOptions;

typedef void (*PhotoMetadataSetGenericValue) (const gchar* tag, void* user_data);
struct _Block1Data {
	int _ref_count_;
	PhotoMetadata * self;
	gchar* value;
};

struct _Block2Data {
	int _ref_count_;
	PhotoMetadata * self;
	GeeCollection* values;
};

struct _Block3Data {
	int _ref_count_;
	PhotoMetadata * self;
	glong value;
};

struct _MetadataRational {
	gint numerator;
	gint denominator;
};

struct _Block4Data {
	int _ref_count_;
	PhotoMetadata * self;
	MetadataRational rational;
};

typedef enum  {
	METADATA_DATE_TIME_ERROR_INVALID_FORMAT,
	METADATA_DATE_TIME_ERROR_UNSUPPORTED_FORMAT
} MetadataDateTimeError;
#define METADATA_DATE_TIME_ERROR metadata_date_time_error_quark ()
struct _Block5Data {
	int _ref_count_;
	PhotoMetadata * self;
	MetadataDateTime* date_time;
};

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

struct _PhotoMetadataInternalPhotoPreview {
	PhotoPreview parent_instance;
	PhotoMetadataInternalPhotoPreviewPrivate * priv;
	PhotoMetadata* owner;
	guint number;
};

struct _PhotoMetadataInternalPhotoPreviewClass {
	PhotoPreviewClass parent_class;
};


static gpointer photo_preview_parent_class = NULL;
static gpointer photo_metadata_parent_class = NULL;
static gchar** photo_metadata_DATE_TIME_TAGS;
static gint photo_metadata_DATE_TIME_TAGS_length1;
static gchar** photo_metadata_DATE_TIME_TAGS = NULL;
static gint photo_metadata_DATE_TIME_TAGS_length1 = 0;
static gint _photo_metadata_DATE_TIME_TAGS_size_ = 0;
static gchar** photo_metadata_EXPOSURE_DATE_TIME_TAGS;
static gint photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1;
static gchar** photo_metadata_EXPOSURE_DATE_TIME_TAGS = NULL;
static gint photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1 = 0;
static gint _photo_metadata_EXPOSURE_DATE_TIME_TAGS_size_ = 0;
static gchar** photo_metadata_DIGITIZED_DATE_TIME_TAGS;
static gint photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1;
static gchar** photo_metadata_DIGITIZED_DATE_TIME_TAGS = NULL;
static gint photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1 = 0;
static gint _photo_metadata_DIGITIZED_DATE_TIME_TAGS_size_ = 0;
static gchar** photo_metadata_WIDTH_TAGS;
static gint photo_metadata_WIDTH_TAGS_length1;
static gchar** photo_metadata_WIDTH_TAGS = NULL;
static gint photo_metadata_WIDTH_TAGS_length1 = 0;
static gint _photo_metadata_WIDTH_TAGS_size_ = 0;
extern gchar** photo_metadata_HEIGHT_TAGS;
extern gint photo_metadata_HEIGHT_TAGS_length1;
gchar** photo_metadata_HEIGHT_TAGS = NULL;
gint photo_metadata_HEIGHT_TAGS_length1 = 0;
static gchar** photo_metadata_STANDARD_TITLE_TAGS;
static gint photo_metadata_STANDARD_TITLE_TAGS_length1;
static gchar** photo_metadata_STANDARD_TITLE_TAGS = NULL;
static gint photo_metadata_STANDARD_TITLE_TAGS_length1 = 0;
static gint _photo_metadata_STANDARD_TITLE_TAGS_size_ = 0;
static gchar** photo_metadata_KEYWORD_TAGS;
static gint photo_metadata_KEYWORD_TAGS_length1;
static gchar** photo_metadata_KEYWORD_TAGS = NULL;
static gint photo_metadata_KEYWORD_TAGS_length1 = 0;
static gint _photo_metadata_KEYWORD_TAGS_size_ = 0;
static HierarchicalKeywordField* photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
static gint photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
static HierarchicalKeywordField* photo_metadata_HIERARCHICAL_KEYWORD_TAGS = NULL;
static gint photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1 = 0;
static gint _photo_metadata_HIERARCHICAL_KEYWORD_TAGS_size_ = 0;
static gchar** photo_metadata_ARTIST_TAGS;
static gint photo_metadata_ARTIST_TAGS_length1;
static gchar** photo_metadata_ARTIST_TAGS = NULL;
static gint photo_metadata_ARTIST_TAGS_length1 = 0;
static gint _photo_metadata_ARTIST_TAGS_size_ = 0;
static gchar** photo_metadata_RATING_TAGS;
static gint photo_metadata_RATING_TAGS_length1;
static gchar** photo_metadata_RATING_TAGS = NULL;
static gint photo_metadata_RATING_TAGS_length1 = 0;
static gint _photo_metadata_RATING_TAGS_size_ = 0;
static gpointer photo_metadata_internal_photo_preview_parent_class = NULL;

GType metadata_domain_get_type (void) G_GNUC_CONST;
GType hierarchical_keyword_field_get_type (void) G_GNUC_CONST;
HierarchicalKeywordField* hierarchical_keyword_field_dup (const HierarchicalKeywordField* self);
void hierarchical_keyword_field_free (HierarchicalKeywordField* self);
void hierarchical_keyword_field_copy (const HierarchicalKeywordField* self, HierarchicalKeywordField* dest);
void hierarchical_keyword_field_destroy (HierarchicalKeywordField* self);
void hierarchical_keyword_field_init (HierarchicalKeywordField *self, const gchar* field_name, const gchar* path_separator, gboolean wants_leading_separator, gboolean is_writeable);
gpointer photo_preview_ref (gpointer instance);
void photo_preview_unref (gpointer instance);
GParamSpec* param_spec_photo_preview (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_preview (GValue* value, gpointer v_object);
void value_take_photo_preview (GValue* value, gpointer v_object);
gpointer value_get_photo_preview (const GValue* value);
GType photo_preview_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
#define PHOTO_PREVIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO_PREVIEW, PhotoPreviewPrivate))
enum  {
	PHOTO_PREVIEW_DUMMY_PROPERTY
};
PhotoPreview* photo_preview_construct (GType object_type, const gchar* name, Dimensions* dimensions, guint32 size, const gchar* mime_type, const gchar* extension);
gchar* photo_preview_get_name (PhotoPreview* self);
void photo_preview_get_pixel_dimensions (PhotoPreview* self, Dimensions* result);
guint32 photo_preview_get_size (PhotoPreview* self);
gchar* photo_preview_get_mime_type (PhotoPreview* self);
gchar* photo_preview_get_extension (PhotoPreview* self);
guint8* photo_preview_flatten (PhotoPreview* self, int* result_length1, GError** error);
static guint8* photo_preview_real_flatten (PhotoPreview* self, int* result_length1, GError** error);
GdkPixbuf* photo_preview_get_pixbuf (PhotoPreview* self, GError** error);
static GdkPixbuf* photo_preview_real_get_pixbuf (PhotoPreview* self, GError** error);
static guint8* _vala_array_dup8 (guint8* self, int length);
static void photo_preview_finalize (PhotoPreview* obj);
gpointer media_metadata_ref (gpointer instance);
void media_metadata_unref (gpointer instance);
GParamSpec* param_spec_media_metadata (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_media_metadata (GValue* value, gpointer v_object);
void value_take_media_metadata (GValue* value, gpointer v_object);
gpointer value_get_media_metadata (const GValue* value);
GType media_metadata_get_type (void) G_GNUC_CONST;
gpointer metadata_date_time_ref (gpointer instance);
void metadata_date_time_unref (gpointer instance);
GParamSpec* param_spec_metadata_date_time (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_metadata_date_time (GValue* value, gpointer v_object);
void value_take_metadata_date_time (GValue* value, gpointer v_object);
gpointer value_get_metadata_date_time (const GValue* value);
GType metadata_date_time_get_type (void) G_GNUC_CONST;
GType photo_metadata_get_type (void) G_GNUC_CONST;
#define PHOTO_METADATA_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO_METADATA, PhotoMetadataPrivate))
enum  {
	PHOTO_METADATA_DUMMY_PROPERTY
};
GType photo_metadata_set_option_get_type (void) G_GNUC_CONST;
GType prepare_input_text_options_get_type (void) G_GNUC_CONST;
#define PHOTO_METADATA_PREPARE_STRING_OPTIONS (((((PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL | PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL) | PREPARE_INPUT_TEXT_OPTIONS_STRIP) | PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF) | PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE) | PREPARE_INPUT_TEXT_OPTIONS_VALIDATE)
#define PHOTO_METADATA_IPHOTO_TITLE_TAG "Iptc.Application2.ObjectName"
PhotoMetadata* photo_metadata_new (void);
PhotoMetadata* photo_metadata_construct (GType object_type);
MediaMetadata* media_metadata_construct (GType object_type);
static void photo_metadata_real_read_from_file (MediaMetadata* base, GFile* file, GError** error);
void photo_metadata_write_to_file (PhotoMetadata* self, GFile* file, GError** error);
void photo_metadata_read_from_buffer (PhotoMetadata* self, guint8* buffer, int buffer_length1, gint length, GError** error);
void photo_metadata_read_from_app1_segment (PhotoMetadata* self, guint8* buffer, int buffer_length1, gint length, GError** error);
MetadataDomain photo_metadata_get_tag_domain (const gchar* tag);
gboolean photo_metadata_has_domain (PhotoMetadata* self, MetadataDomain domain);
gboolean photo_metadata_has_exif (PhotoMetadata* self);
gboolean photo_metadata_has_xmp (PhotoMetadata* self);
gboolean photo_metadata_has_iptc (PhotoMetadata* self);
gboolean photo_metadata_can_write_to_domain (PhotoMetadata* self, MetadataDomain domain);
gboolean photo_metadata_can_write_exif (PhotoMetadata* self);
gboolean photo_metadata_can_write_xmp (PhotoMetadata* self);
gboolean photo_metadata_can_write_iptc (PhotoMetadata* self);
gboolean photo_metadata_has_tag (PhotoMetadata* self, const gchar* tag);
static GeeSet* photo_metadata_create_string_set (PhotoMetadata* self, GCompareFunc compare_func);
GeeCollection* photo_metadata_get_tags (PhotoMetadata* self, MetadataDomain domain, GCompareFunc compare_func);
GeeCollection* photo_metadata_get_all_tags (PhotoMetadata* self, GCompareFunc compare_func);
gchar* photo_metadata_get_tag_label (PhotoMetadata* self, const gchar* tag);
gchar* photo_metadata_get_tag_description (PhotoMetadata* self, const gchar* tag);
gchar* photo_metadata_get_string (PhotoMetadata* self, const gchar* tag);
gchar* prepare_input_text (const gchar* text, PrepareInputTextOptions options, gint dest_length);
#define DEFAULT_USER_TEXT_INPUT_LENGTH 1024
gchar* photo_metadata_get_string_interpreted (PhotoMetadata* self, const gchar* tag);
gchar* photo_metadata_get_first_string (PhotoMetadata* self, gchar** tags, int tags_length1);
gchar* photo_metadata_get_first_string_interpreted (PhotoMetadata* self, gchar** tags, int tags_length1);
GeeList* photo_metadata_get_string_multiple (PhotoMetadata* self, const gchar* tag);
GeeList* photo_metadata_get_first_string_multiple (PhotoMetadata* self, gchar** tags, int tags_length1);
void photo_metadata_set_string (PhotoMetadata* self, const gchar* tag, const gchar* value);
static void photo_metadata_set_all_generic (PhotoMetadata* self, gchar** tags, int tags_length1, PhotoMetadataSetOption option, PhotoMetadataSetGenericValue setter, void* setter_target);
void photo_metadata_set_all_string (PhotoMetadata* self, gchar** tags, int tags_length1, const gchar* value, PhotoMetadataSetOption option);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (Block1Data* _data1_);
static void _lambda1_ (const gchar* tag, Block1Data* _data1_);
static void __lambda1__photo_metadata_set_generic_value (const gchar* tag, gpointer self);
void photo_metadata_set_string_multiple (PhotoMetadata* self, const gchar* tag, GeeCollection* collection);
static void _vala_array_add13 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add14 (gchar*** array, int* length, int* size, gchar* value);
void photo_metadata_set_all_string_multiple (PhotoMetadata* self, gchar** tags, int tags_length1, GeeCollection* values, PhotoMetadataSetOption option);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (Block2Data* _data2_);
static void _lambda2_ (const gchar* tag, Block2Data* _data2_);
static void __lambda2__photo_metadata_set_generic_value (const gchar* tag, gpointer self);
gboolean photo_metadata_get_long (PhotoMetadata* self, const gchar* tag, glong* value);
gboolean photo_metadata_get_first_long (PhotoMetadata* self, gchar** tags, int tags_length1, glong* value);
void photo_metadata_set_long (PhotoMetadata* self, const gchar* tag, glong value);
void photo_metadata_set_all_long (PhotoMetadata* self, gchar** tags, int tags_length1, glong value, PhotoMetadataSetOption option);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (Block3Data* _data3_);
static void _lambda3_ (const gchar* tag, Block3Data* _data3_);
static void __lambda3__photo_metadata_set_generic_value (const gchar* tag, gpointer self);
GType metadata_rational_get_type (void) G_GNUC_CONST;
MetadataRational* metadata_rational_dup (const MetadataRational* self);
void metadata_rational_free (MetadataRational* self);
gboolean photo_metadata_get_rational (PhotoMetadata* self, const gchar* tag, MetadataRational* rational);
gboolean photo_metadata_get_first_rational (PhotoMetadata* self, gchar** tags, int tags_length1, MetadataRational* rational);
void photo_metadata_set_rational (PhotoMetadata* self, const gchar* tag, MetadataRational* rational);
gchar* metadata_rational_to_string (MetadataRational *self);
void photo_metadata_set_all_rational (PhotoMetadata* self, gchar** tags, int tags_length1, MetadataRational* rational, PhotoMetadataSetOption option);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (Block4Data* _data4_);
static void _lambda4_ (const gchar* tag, Block4Data* _data4_);
static void __lambda4__photo_metadata_set_generic_value (const gchar* tag, gpointer self);
MetadataDateTime* photo_metadata_get_date_time (PhotoMetadata* self, const gchar* tag);
GQuark metadata_date_time_error_quark (void);
MetadataDateTime* metadata_date_time_new_from_xmp (const gchar* label, GError** error);
MetadataDateTime* metadata_date_time_construct_from_xmp (GType object_type, const gchar* label, GError** error);
MetadataDateTime* metadata_date_time_new_from_exif (const gchar* label, GError** error);
MetadataDateTime* metadata_date_time_construct_from_exif (GType object_type, const gchar* label, GError** error);
MetadataDateTime* photo_metadata_get_first_date_time (PhotoMetadata* self, gchar** tags, int tags_length1);
void photo_metadata_set_date_time (PhotoMetadata* self, const gchar* tag, MetadataDateTime* date_time);
gchar* metadata_date_time_get_exif_label (MetadataDateTime* self);
gchar* metadata_date_time_get_xmp_label (MetadataDateTime* self);
const gchar* metadata_domain_to_string (MetadataDomain self);
void photo_metadata_set_all_date_time (PhotoMetadata* self, gchar** tags, int tags_length1, MetadataDateTime* date_time, PhotoMetadataSetOption option);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (Block5Data* _data5_);
static void _lambda5_ (const gchar* tag, Block5Data* _data5_);
static void __lambda5__photo_metadata_set_generic_value (const gchar* tag, gpointer self);
guint8* photo_metadata_flatten_exif (PhotoMetadata* self, gboolean include_preview, int* result_length1);
guint8* photo_metadata_flatten_exif_preview (PhotoMetadata* self, int* result_length1);
static guint8* _vala_array_dup9 (guint8* self, int length);
guint photo_metadata_get_preview_count (PhotoMetadata* self);
PhotoPreview* photo_metadata_get_preview (PhotoMetadata* self, guint number);
static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_new (PhotoMetadata* owner, const gchar* name, guint number, GExiv2PreviewProperties* props);
static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_construct (GType object_type, PhotoMetadata* owner, const gchar* name, guint number, GExiv2PreviewProperties* props);
static GType photo_metadata_internal_photo_preview_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void photo_metadata_remove_exif_thumbnail (PhotoMetadata* self);
void photo_metadata_remove_tag (PhotoMetadata* self, const gchar* tag);
void photo_metadata_remove_tags (PhotoMetadata* self, gchar** tags, int tags_length1);
void photo_metadata_clear_domain (PhotoMetadata* self, MetadataDomain domain);
void photo_metadata_clear (PhotoMetadata* self);
MetadataDateTime* photo_metadata_get_modification_date_time (PhotoMetadata* self);
void photo_metadata_set_modification_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option);
MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self);
void photo_metadata_set_exposure_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option);
MetadataDateTime* photo_metadata_get_digitized_date_time (PhotoMetadata* self);
void photo_metadata_set_digitized_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option);
static MetadataDateTime* photo_metadata_real_get_creation_date_time (MediaMetadata* base);
Dimensions* photo_metadata_get_pixel_dimensions (PhotoMetadata* self);
void dimensions_init (Dimensions *self, gint width, gint height);
void photo_metadata_set_pixel_dimensions (PhotoMetadata* self, Dimensions* dim, PhotoMetadataSetOption option);
static gchar* photo_metadata_real_get_title (MediaMetadata* base);
gboolean is_string_empty (const gchar* s);
void photo_metadata_set_title (PhotoMetadata* self, const gchar* title, PhotoMetadataSetOption option);
GeeSet* photo_metadata_get_keywords (PhotoMetadata* self, GCompareFunc compare_func);
gchar* hierarchical_tag_utilities_make_flat_tag_safe (const gchar* in_tag);
gpointer hierarchical_tag_index_ref (gpointer instance);
void hierarchical_tag_index_unref (gpointer instance);
GParamSpec* param_spec_hierarchical_tag_index (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_hierarchical_tag_index (GValue* value, gpointer v_object);
void value_take_hierarchical_tag_index (GValue* value, gpointer v_object);
gpointer value_get_hierarchical_tag_index (const GValue* value);
GType hierarchical_tag_index_get_type (void) G_GNUC_CONST;
static void photo_metadata_internal_set_hierarchical_keywords (PhotoMetadata* self, HierarchicalTagIndex* index);
GeeCollection* hierarchical_tag_index_get_all_paths (HierarchicalTagIndex* self);
#define TAG_PATH_SEPARATOR_STRING "/"
void photo_metadata_set_keywords (PhotoMetadata* self, GeeCollection* keywords, PhotoMetadataSetOption option);
HierarchicalTagIndex* hierarchical_tag_index_new (void);
HierarchicalTagIndex* hierarchical_tag_index_construct (GType object_type);
GeeList* hierarchical_tag_utilities_enumerate_path_components (const gchar* in_path);
void hierarchical_tag_index_add_path (HierarchicalTagIndex* self, const gchar* tag, const gchar* path);
GeeCollection* hierarchical_tag_index_get_all_tags (HierarchicalTagIndex* self);
gboolean photo_metadata_has_hierarchical_keywords (PhotoMetadata* self);
GeeSet* photo_metadata_get_hierarchical_keywords (PhotoMetadata* self);
gchar* hierarchical_tag_utilities_canonicalize (const gchar* in_tag, const gchar* foreign_separator);
gboolean photo_metadata_has_orientation (PhotoMetadata* self);
GType orientation_get_type (void) G_GNUC_CONST;
Orientation photo_metadata_get_orientation (PhotoMetadata* self);
void photo_metadata_set_orientation (PhotoMetadata* self, Orientation orientation);
gboolean photo_metadata_get_gps (PhotoMetadata* self, gdouble* longitude, gchar** long_ref, gdouble* latitude, gchar** lat_ref, gdouble* altitude);
gboolean photo_metadata_get_exposure (PhotoMetadata* self, MetadataRational* exposure);
gchar* photo_metadata_get_exposure_string (PhotoMetadata* self);
gboolean metadata_rational_is_valid (MetadataRational *self);
gboolean photo_metadata_get_iso (PhotoMetadata* self, glong* iso);
gchar* photo_metadata_get_iso_string (PhotoMetadata* self);
gboolean photo_metadata_get_aperture (PhotoMetadata* self, MetadataRational* aperture);
gchar* photo_metadata_get_aperture_string (PhotoMetadata* self, gboolean pango_formatted);
gchar* photo_metadata_get_camera_make (PhotoMetadata* self);
gchar* photo_metadata_get_camera_model (PhotoMetadata* self);
gboolean photo_metadata_get_flash (PhotoMetadata* self, glong* flash);
gchar* photo_metadata_get_flash_string (PhotoMetadata* self);
gboolean photo_metadata_get_focal_length (PhotoMetadata* self, MetadataRational* focal_length);
gchar* photo_metadata_get_focal_length_string (PhotoMetadata* self);
gchar* photo_metadata_get_artist (PhotoMetadata* self);
gchar* photo_metadata_get_copyright (PhotoMetadata* self);
gchar* photo_metadata_get_software (PhotoMetadata* self);
void photo_metadata_set_software (PhotoMetadata* self, const gchar* software, const gchar* version);
void photo_metadata_remove_software (PhotoMetadata* self);
gchar* photo_metadata_get_exposure_bias (PhotoMetadata* self);
GType rating_get_type (void) G_GNUC_CONST;
Rating photo_metadata_get_rating (PhotoMetadata* self);
Rating rating_unserialize (gint value);
void photo_metadata_set_rating (PhotoMetadata* self, Rating rating);
gint rating_serialize (Rating self);
enum  {
	PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW_DUMMY_PROPERTY
};
static guint8* photo_metadata_internal_photo_preview_real_flatten (PhotoPreview* base, int* result_length1, GError** error);
static guint8* _vala_array_dup10 (guint8* self, int length);
static void photo_metadata_internal_photo_preview_finalize (PhotoPreview* obj);
static void photo_metadata_finalize (MediaMetadata* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


GType metadata_domain_get_type (void) {
	static volatile gsize metadata_domain_type_id__volatile = 0;
	if (g_once_init_enter (&metadata_domain_type_id__volatile)) {
		static const GEnumValue values[] = {{METADATA_DOMAIN_UNKNOWN, "METADATA_DOMAIN_UNKNOWN", "unknown"}, {METADATA_DOMAIN_EXIF, "METADATA_DOMAIN_EXIF", "exif"}, {METADATA_DOMAIN_XMP, "METADATA_DOMAIN_XMP", "xmp"}, {METADATA_DOMAIN_IPTC, "METADATA_DOMAIN_IPTC", "iptc"}, {0, NULL, NULL}};
		GType metadata_domain_type_id;
		metadata_domain_type_id = g_enum_register_static ("MetadataDomain", values);
		g_once_init_leave (&metadata_domain_type_id__volatile, metadata_domain_type_id);
	}
	return metadata_domain_type_id__volatile;
}


void hierarchical_keyword_field_init (HierarchicalKeywordField *self, const gchar* field_name, const gchar* path_separator, gboolean wants_leading_separator, gboolean is_writeable) {
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (field_name != NULL);
	g_return_if_fail (path_separator != NULL);
	memset (self, 0, sizeof (HierarchicalKeywordField));
	_tmp0_ = g_strdup (field_name);
	_g_free0 ((*self).field_name);
	(*self).field_name = _tmp0_;
	_tmp1_ = g_strdup (path_separator);
	_g_free0 ((*self).path_separator);
	(*self).path_separator = _tmp1_;
	(*self).wants_leading_separator = wants_leading_separator;
	(*self).is_writeable = is_writeable;
}


void hierarchical_keyword_field_copy (const HierarchicalKeywordField* self, HierarchicalKeywordField* dest) {
	dest->field_name = g_strdup (self->field_name);
	dest->path_separator = g_strdup (self->path_separator);
	dest->wants_leading_separator = self->wants_leading_separator;
	dest->is_writeable = self->is_writeable;
}


void hierarchical_keyword_field_destroy (HierarchicalKeywordField* self) {
	_g_free0 ((*self).field_name);
	_g_free0 ((*self).path_separator);
}


HierarchicalKeywordField* hierarchical_keyword_field_dup (const HierarchicalKeywordField* self) {
	HierarchicalKeywordField* dup;
	dup = g_new0 (HierarchicalKeywordField, 1);
	hierarchical_keyword_field_copy (self, dup);
	return dup;
}


void hierarchical_keyword_field_free (HierarchicalKeywordField* self) {
	hierarchical_keyword_field_destroy (self);
	g_free (self);
}


GType hierarchical_keyword_field_get_type (void) {
	static volatile gsize hierarchical_keyword_field_type_id__volatile = 0;
	if (g_once_init_enter (&hierarchical_keyword_field_type_id__volatile)) {
		GType hierarchical_keyword_field_type_id;
		hierarchical_keyword_field_type_id = g_boxed_type_register_static ("HierarchicalKeywordField", (GBoxedCopyFunc) hierarchical_keyword_field_dup, (GBoxedFreeFunc) hierarchical_keyword_field_free);
		g_once_init_leave (&hierarchical_keyword_field_type_id__volatile, hierarchical_keyword_field_type_id);
	}
	return hierarchical_keyword_field_type_id__volatile;
}


PhotoPreview* photo_preview_construct (GType object_type, const gchar* name, Dimensions* dimensions, guint32 size, const gchar* mime_type, const gchar* extension) {
	PhotoPreview* self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (mime_type != NULL, NULL);
	g_return_val_if_fail (extension != NULL, NULL);
	self = (PhotoPreview*) g_type_create_instance (object_type);
	_tmp0_ = g_strdup (name);
	_g_free0 (self->priv->name);
	self->priv->name = _tmp0_;
	self->priv->dimensions = *dimensions;
	self->priv->size = size;
	_tmp1_ = g_strdup (mime_type);
	_g_free0 (self->priv->mime_type);
	self->priv->mime_type = _tmp1_;
	_tmp2_ = g_strdup (extension);
	_g_free0 (self->priv->extension);
	self->priv->extension = _tmp2_;
	return self;
}


gchar* photo_preview_get_name (PhotoPreview* self) {
	gchar* result = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
	_tmp0_ = g_strdup (self->priv->name);
	result = _tmp0_;
	return result;
}


void photo_preview_get_pixel_dimensions (PhotoPreview* self, Dimensions* result) {
	g_return_if_fail (IS_PHOTO_PREVIEW (self));
	*result = self->priv->dimensions;
	return;
}


guint32 photo_preview_get_size (PhotoPreview* self) {
	guint32 result = 0U;
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), 0U);
	result = self->priv->size;
	return result;
}


gchar* photo_preview_get_mime_type (PhotoPreview* self) {
	gchar* result = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
	_tmp0_ = g_strdup (self->priv->mime_type);
	result = _tmp0_;
	return result;
}


gchar* photo_preview_get_extension (PhotoPreview* self) {
	gchar* result = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
	_tmp0_ = g_strdup (self->priv->extension);
	result = _tmp0_;
	return result;
}


static guint8* photo_preview_real_flatten (PhotoPreview* self, int* result_length1, GError** error) {
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `photo_preview_flatten'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


guint8* photo_preview_flatten (PhotoPreview* self, int* result_length1, GError** error) {
	return PHOTO_PREVIEW_GET_CLASS (self)->flatten (self, result_length1, error);
}


static guint8* _vala_array_dup8 (guint8* self, int length) {
	return g_memdup (self, length * sizeof (guint8));
}


static GdkPixbuf* photo_preview_real_get_pixbuf (PhotoPreview* self, GError** error) {
	GdkPixbuf* result = NULL;
	gint _tmp0_;
	guint8* _tmp1_ = NULL;
	guint8* flattened;
	gint flattened_length1;
	gint _flattened_size_;
	guint8* _tmp2_;
	guint8* _tmp3_;
	GMemoryInputStream* _tmp4_ = NULL;
	GMemoryInputStream* _tmp5_;
	GdkPixbuf* _tmp6_ = NULL;
	GdkPixbuf* _tmp7_;
	GdkPixbuf* _tmp8_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
	_tmp1_ = photo_preview_flatten (self, &_tmp0_, &_inner_error_);
	flattened = _tmp1_;
	flattened_length1 = _tmp0_;
	_flattened_size_ = _tmp0_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	_tmp2_ = (_tmp3_ = flattened, (_tmp3_ == NULL) ? ((gpointer) _tmp3_) : _vala_array_dup8 (_tmp3_, flattened_length1));
	_tmp4_ = (GMemoryInputStream*) g_memory_input_stream_new_from_data (_tmp2_, flattened_length1, NULL);
	_tmp5_ = _tmp4_;
	_tmp6_ = gdk_pixbuf_new_from_stream (G_INPUT_STREAM (_tmp5_), NULL, &_inner_error_);
	_tmp7_ = _tmp6_;
	_g_object_unref0 (_tmp5_);
	_tmp8_ = _tmp7_;
	if (_inner_error_ != NULL) {
		goto __catch22_g_error;
	}
	result = _tmp8_;
	flattened = (g_free (flattened), NULL);
	return result;
	goto __finally22;
	__catch22_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		g_warning ("PhotoMetadata.vala:92: Unable to decode thumbnail for %s: %s", self->priv->name, err->message);
		result = NULL;
		_g_error_free0 (err);
		flattened = (g_free (flattened), NULL);
		return result;
	}
	__finally22:
	g_propagate_error (error, _inner_error_);
	flattened = (g_free (flattened), NULL);
	return NULL;
}


GdkPixbuf* photo_preview_get_pixbuf (PhotoPreview* self, GError** error) {
	return PHOTO_PREVIEW_GET_CLASS (self)->get_pixbuf (self, error);
}


static void value_photo_preview_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_photo_preview_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		photo_preview_unref (value->data[0].v_pointer);
	}
}


static void value_photo_preview_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = photo_preview_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_photo_preview_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_photo_preview_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		PhotoPreview* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = photo_preview_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_photo_preview_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoPreview** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = photo_preview_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_photo_preview (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecPhotoPreview* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_PREVIEW), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_photo_preview (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW), NULL);
	return value->data[0].v_pointer;
}


void value_set_photo_preview (GValue* value, gpointer v_object) {
	PhotoPreview* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_PREVIEW));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		photo_preview_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		photo_preview_unref (old);
	}
}


void value_take_photo_preview (GValue* value, gpointer v_object) {
	PhotoPreview* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_PREVIEW));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		photo_preview_unref (old);
	}
}


static void photo_preview_class_init (PhotoPreviewClass * klass) {
	photo_preview_parent_class = g_type_class_peek_parent (klass);
	PHOTO_PREVIEW_CLASS (klass)->finalize = photo_preview_finalize;
	g_type_class_add_private (klass, sizeof (PhotoPreviewPrivate));
	PHOTO_PREVIEW_CLASS (klass)->flatten = photo_preview_real_flatten;
	PHOTO_PREVIEW_CLASS (klass)->get_pixbuf = photo_preview_real_get_pixbuf;
}


static void photo_preview_instance_init (PhotoPreview * self) {
	self->priv = PHOTO_PREVIEW_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void photo_preview_finalize (PhotoPreview* obj) {
	PhotoPreview * self;
	self = PHOTO_PREVIEW (obj);
	_g_free0 (self->priv->name);
	_g_free0 (self->priv->mime_type);
	_g_free0 (self->priv->extension);
}


GType photo_preview_get_type (void) {
	static volatile gsize photo_preview_type_id__volatile = 0;
	if (g_once_init_enter (&photo_preview_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_photo_preview_init, value_photo_preview_free_value, value_photo_preview_copy_value, value_photo_preview_peek_pointer, "p", value_photo_preview_collect_value, "p", value_photo_preview_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoPreviewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_preview_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoPreview), 0, (GInstanceInitFunc) photo_preview_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_preview_type_id;
		photo_preview_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoPreview", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_preview_type_id__volatile, photo_preview_type_id);
	}
	return photo_preview_type_id__volatile;
}


gpointer photo_preview_ref (gpointer instance) {
	PhotoPreview* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void photo_preview_unref (gpointer instance) {
	PhotoPreview* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		PHOTO_PREVIEW_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


GType photo_metadata_set_option_get_type (void) {
	static volatile gsize photo_metadata_set_option_type_id__volatile = 0;
	if (g_once_init_enter (&photo_metadata_set_option_type_id__volatile)) {
		static const GEnumValue values[] = {{PHOTO_METADATA_SET_OPTION_ALL_DOMAINS, "PHOTO_METADATA_SET_OPTION_ALL_DOMAINS", "all-domains"}, {PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT, "PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT", "only-if-domain-present"}, {PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN, "PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN", "at-least-default-domain"}, {0, NULL, NULL}};
		GType photo_metadata_set_option_type_id;
		photo_metadata_set_option_type_id = g_enum_register_static ("PhotoMetadataSetOption", values);
		g_once_init_leave (&photo_metadata_set_option_type_id__volatile, photo_metadata_set_option_type_id);
	}
	return photo_metadata_set_option_type_id__volatile;
}


PhotoMetadata* photo_metadata_construct (GType object_type) {
	PhotoMetadata* self = NULL;
	self = (PhotoMetadata*) media_metadata_construct (object_type);
	return self;
}


PhotoMetadata* photo_metadata_new (void) {
	return photo_metadata_construct (TYPE_PHOTO_METADATA);
}


static void photo_metadata_real_read_from_file (MediaMetadata* base, GFile* file, GError** error) {
	PhotoMetadata * self;
	GExiv2Metadata* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	ExifData* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	GError * _inner_error_ = NULL;
	self = PHOTO_METADATA (base);
	g_return_if_fail (G_IS_FILE (file));
	_tmp0_ = gexiv2_metadata_new ();
	_gexiv2_metadata_free0 (self->priv->exiv2);
	self->priv->exiv2 = _tmp0_;
	_exif_data_unref0 (self->priv->exif);
	self->priv->exif = NULL;
	_tmp1_ = g_file_get_path (file);
	_tmp2_ = _tmp1_;
	gexiv2_metadata_open_path (self->priv->exiv2, _tmp2_, &_inner_error_);
	_g_free0 (_tmp2_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp3_ = g_file_get_path (file);
	_tmp4_ = _tmp3_;
	_tmp5_ = exif_data_new_from_file (_tmp4_);
	_exif_data_unref0 (self->priv->exif);
	self->priv->exif = _tmp5_;
	_g_free0 (_tmp4_);
	_tmp6_ = g_file_get_basename (file);
	_g_free0 (self->priv->source_name);
	self->priv->source_name = _tmp6_;
}


void photo_metadata_write_to_file (PhotoMetadata* self, GFile* file, GError** error) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO_METADATA (self));
	g_return_if_fail (G_IS_FILE (file));
	_tmp0_ = g_file_get_path (file);
	_tmp1_ = _tmp0_;
	gexiv2_metadata_save_file (self->priv->exiv2, _tmp1_, &_inner_error_);
	_g_free0 (_tmp1_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
}


void photo_metadata_read_from_buffer (PhotoMetadata* self, guint8* buffer, int buffer_length1, gint length, GError** error) {
	GExiv2Metadata* _tmp0_ = NULL;
	ExifData* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO_METADATA (self));
	if (length <= 0) {
		length = buffer_length1;
	}
	g_assert (buffer_length1 >= length);
	_tmp0_ = gexiv2_metadata_new ();
	_gexiv2_metadata_free0 (self->priv->exiv2);
	self->priv->exiv2 = _tmp0_;
	_exif_data_unref0 (self->priv->exif);
	self->priv->exif = NULL;
	gexiv2_metadata_open_buf (self->priv->exiv2, buffer, (glong) length, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp1_ = exif_data_new_from_data (buffer, (gsize) length);
	_exif_data_unref0 (self->priv->exif);
	self->priv->exif = _tmp1_;
	_tmp2_ = g_strdup_printf ("<memory buffer %d bytes>", length);
	_g_free0 (self->priv->source_name);
	self->priv->source_name = _tmp2_;
}


void photo_metadata_read_from_app1_segment (PhotoMetadata* self, guint8* buffer, int buffer_length1, gint length, GError** error) {
	GExiv2Metadata* _tmp0_ = NULL;
	ExifData* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_PHOTO_METADATA (self));
	if (length <= 0) {
		length = buffer_length1;
	}
	g_assert (buffer_length1 >= length);
	_tmp0_ = gexiv2_metadata_new ();
	_gexiv2_metadata_free0 (self->priv->exiv2);
	self->priv->exiv2 = _tmp0_;
	_exif_data_unref0 (self->priv->exif);
	self->priv->exif = NULL;
	gexiv2_metadata_from_app1_segment (self->priv->exiv2, buffer, (glong) length, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
	_tmp1_ = exif_data_new_from_data (buffer, (gsize) length);
	_exif_data_unref0 (self->priv->exif);
	self->priv->exif = _tmp1_;
	_tmp2_ = g_strdup_printf ("<app1 segment %d bytes>", length);
	_g_free0 (self->priv->source_name);
	self->priv->source_name = _tmp2_;
}


MetadataDomain photo_metadata_get_tag_domain (const gchar* tag) {
	MetadataDomain result = 0;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (tag != NULL, 0);
	_tmp0_ = gexiv2_metadata_is_exif_tag (tag);
	if (_tmp0_) {
		result = METADATA_DOMAIN_EXIF;
		return result;
	}
	_tmp1_ = gexiv2_metadata_is_xmp_tag (tag);
	if (_tmp1_) {
		result = METADATA_DOMAIN_XMP;
		return result;
	}
	_tmp2_ = gexiv2_metadata_is_iptc_tag (tag);
	if (_tmp2_) {
		result = METADATA_DOMAIN_IPTC;
		return result;
	}
	result = METADATA_DOMAIN_UNKNOWN;
	return result;
}


gboolean photo_metadata_has_domain (PhotoMetadata* self, MetadataDomain domain) {
	gboolean result = FALSE;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
	switch (domain) {
		case METADATA_DOMAIN_EXIF:
		{
			gboolean _tmp0_;
			_tmp0_ = gexiv2_metadata_has_exif (self->priv->exiv2);
			result = _tmp0_;
			return result;
		}
		case METADATA_DOMAIN_XMP:
		{
			gboolean _tmp1_;
			_tmp1_ = gexiv2_metadata_has_xmp (self->priv->exiv2);
			result = _tmp1_;
			return result;
		}
		case METADATA_DOMAIN_IPTC:
		{
			gboolean _tmp2_;
			_tmp2_ = gexiv2_metadata_has_iptc (self->priv->exiv2);
			result = _tmp2_;
			return result;
		}
		default:
		case METADATA_DOMAIN_UNKNOWN:
		{
			result = FALSE;
			return result;
		}
	}
}


gboolean photo_metadata_has_exif (PhotoMetadata* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
	_tmp0_ = photo_metadata_has_domain (self, METADATA_DOMAIN_EXIF);
	result = _tmp0_;
	return result;
}


gboolean photo_metadata_has_xmp (PhotoMetadata* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
	_tmp0_ = photo_metadata_has_domain (self, METADATA_DOMAIN_XMP);
	result = _tmp0_;
	return result;
}


gboolean photo_metadata_has_iptc (PhotoMetadata* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
	_tmp0_ = photo_metadata_has_domain (self, METADATA_DOMAIN_IPTC);
	result = _tmp0_;
	return result;
}


gboolean photo_metadata_can_write_to_domain (PhotoMetadata* self, MetadataDomain domain) {
	gboolean result = FALSE;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
	switch (domain) {
		case METADATA_DOMAIN_EXIF:
		{
			gboolean _tmp0_;
			_tmp0_ = gexiv2_metadata_get_supports_exif (self->priv->exiv2);
			result = _tmp0_;
			return result;
		}
		case METADATA_DOMAIN_XMP:
		{
			gboolean _tmp1_;
			_tmp1_ = gexiv2_metadata_get_supports_xmp (self->priv->exiv2);
			result = _tmp1_;
			return result;
		}
		case METADATA_DOMAIN_IPTC:
		{
			gboolean _tmp2_;
			_tmp2_ = gexiv2_metadata_get_supports_iptc (self->priv->exiv2);
			result = _tmp2_;
			return result;
		}
		default:
		case METADATA_DOMAIN_UNKNOWN:
		{
			result = FALSE;
			return result;
		}
	}
}


gboolean photo_metadata_can_write_exif (PhotoMetadata* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
	_tmp0_ = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_EXIF);
	result = _tmp0_;
	return result;
}


gboolean photo_metadata_can_write_xmp (PhotoMetadata* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
	_tmp0_ = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_XMP);
	result = _tmp0_;
	return result;
}


gboolean photo_metadata_can_write_iptc (PhotoMetadata* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
	_tmp0_ = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_IPTC);
	result = _tmp0_;
	return result;
}


gboolean photo_metadata_has_tag (PhotoMetadata* self, const gchar* tag) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
	g_return_val_if_fail (tag != NULL, FALSE);
	_tmp0_ = gexiv2_metadata_has_tag (self->priv->exiv2, tag);
	result = _tmp0_;
	return result;
}


static GeeSet* photo_metadata_create_string_set (PhotoMetadata* self, GCompareFunc compare_func) {
	GeeSet* result = NULL;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	if (compare_func == NULL) {
		GeeHashSet* _tmp0_ = NULL;
		_tmp0_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL);
		result = GEE_SET (_tmp0_);
		return result;
	} else {
		GeeTreeSet* _tmp1_ = NULL;
		_tmp1_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, compare_func);
		result = GEE_SET (_tmp1_);
		return result;
	}
}


GeeCollection* photo_metadata_get_tags (PhotoMetadata* self, MetadataDomain domain, GCompareFunc compare_func) {
	GeeCollection* result = NULL;
	gchar** tags;
	gint tags_length1;
	gint _tags_size_;
	gboolean _tmp6_ = FALSE;
	GeeSet* _tmp7_ = NULL;
	GeeCollection* collection;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	tags = NULL;
	tags_length1 = 0;
	_tags_size_ = 0;
	switch (domain) {
		case METADATA_DOMAIN_EXIF:
		{
			gchar** _tmp0_;
			gchar** _tmp1_ = NULL;
			_tmp1_ = _tmp0_ = gexiv2_metadata_get_exif_tags (self->priv->exiv2);
			tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
			tags = _tmp1_;
			tags_length1 = _vala_array_length (_tmp0_);
			_tags_size_ = _vala_array_length (_tmp0_);
			break;
		}
		case METADATA_DOMAIN_XMP:
		{
			gchar** _tmp2_;
			gchar** _tmp3_ = NULL;
			_tmp3_ = _tmp2_ = gexiv2_metadata_get_xmp_tags (self->priv->exiv2);
			tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
			tags = _tmp3_;
			tags_length1 = _vala_array_length (_tmp2_);
			_tags_size_ = _vala_array_length (_tmp2_);
			break;
		}
		case METADATA_DOMAIN_IPTC:
		{
			gchar** _tmp4_;
			gchar** _tmp5_ = NULL;
			_tmp5_ = _tmp4_ = gexiv2_metadata_get_iptc_tags (self->priv->exiv2);
			tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
			tags = _tmp5_;
			tags_length1 = _vala_array_length (_tmp4_);
			_tags_size_ = _vala_array_length (_tmp4_);
			break;
		}
		default:
		break;
	}
	if (tags == NULL) {
		_tmp6_ = TRUE;
	} else {
		_tmp6_ = tags_length1 == 0;
	}
	if (_tmp6_) {
		result = NULL;
		tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	_tmp7_ = photo_metadata_create_string_set (self, compare_func);
	collection = GEE_COLLECTION (_tmp7_);
	{
		gchar** tag_collection;
		int tag_collection_length1;
		int tag_it;
		tag_collection = tags;
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			gchar* _tmp8_;
			gchar* tag;
			_tmp8_ = g_strdup (tag_collection[tag_it]);
			tag = _tmp8_;
			{
				gee_collection_add (collection, tag);
				_g_free0 (tag);
			}
		}
	}
	result = collection;
	tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


GeeCollection* photo_metadata_get_all_tags (PhotoMetadata* self, GCompareFunc compare_func) {
	GeeCollection* result = NULL;
	GeeSet* _tmp0_ = NULL;
	GeeCollection* all_tags;
	GeeCollection* _tmp1_ = NULL;
	GeeCollection* exif_tags;
	gboolean _tmp2_ = FALSE;
	GeeCollection* _tmp4_ = NULL;
	GeeCollection* xmp_tags;
	gboolean _tmp5_ = FALSE;
	GeeCollection* _tmp7_ = NULL;
	GeeCollection* iptc_tags;
	gboolean _tmp8_ = FALSE;
	GeeCollection* _tmp10_ = NULL;
	gint _tmp11_;
	GeeCollection* _tmp12_;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	_tmp0_ = photo_metadata_create_string_set (self, compare_func);
	all_tags = GEE_COLLECTION (_tmp0_);
	_tmp1_ = photo_metadata_get_tags (self, METADATA_DOMAIN_EXIF, NULL);
	exif_tags = _tmp1_;
	if (exif_tags != NULL) {
		gint _tmp3_;
		_tmp3_ = gee_collection_get_size (exif_tags);
		_tmp2_ = _tmp3_ > 0;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		gee_collection_add_all (all_tags, exif_tags);
	}
	_tmp4_ = photo_metadata_get_tags (self, METADATA_DOMAIN_XMP, NULL);
	xmp_tags = _tmp4_;
	if (xmp_tags != NULL) {
		gint _tmp6_;
		_tmp6_ = gee_collection_get_size (xmp_tags);
		_tmp5_ = _tmp6_ > 0;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		gee_collection_add_all (all_tags, xmp_tags);
	}
	_tmp7_ = photo_metadata_get_tags (self, METADATA_DOMAIN_IPTC, NULL);
	iptc_tags = _tmp7_;
	if (iptc_tags != NULL) {
		gint _tmp9_;
		_tmp9_ = gee_collection_get_size (iptc_tags);
		_tmp8_ = _tmp9_ > 0;
	} else {
		_tmp8_ = FALSE;
	}
	if (_tmp8_) {
		gee_collection_add_all (all_tags, iptc_tags);
	}
	_tmp11_ = gee_collection_get_size (all_tags);
	if (_tmp11_ > 0) {
		_tmp10_ = all_tags;
	} else {
		_tmp10_ = NULL;
	}
	_tmp12_ = _g_object_ref0 (_tmp10_);
	result = _tmp12_;
	_g_object_unref0 (iptc_tags);
	_g_object_unref0 (xmp_tags);
	_g_object_unref0 (exif_tags);
	_g_object_unref0 (all_tags);
	return result;
}


gchar* photo_metadata_get_tag_label (PhotoMetadata* self, const gchar* tag) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	g_return_val_if_fail (tag != NULL, NULL);
	_tmp0_ = gexiv2_metadata_get_tag_label (tag);
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}


gchar* photo_metadata_get_tag_description (PhotoMetadata* self, const gchar* tag) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	g_return_val_if_fail (tag != NULL, NULL);
	_tmp0_ = gexiv2_metadata_get_tag_description (tag);
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}


gchar* photo_metadata_get_string (PhotoMetadata* self, const gchar* tag) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	g_return_val_if_fail (tag != NULL, NULL);
	_tmp0_ = gexiv2_metadata_get_tag_string (self->priv->exiv2, tag);
	_tmp1_ = _tmp0_;
	_tmp2_ = prepare_input_text (_tmp1_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	result = _tmp3_;
	return result;
}


gchar* photo_metadata_get_string_interpreted (PhotoMetadata* self, const gchar* tag) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	g_return_val_if_fail (tag != NULL, NULL);
	_tmp0_ = gexiv2_metadata_get_tag_interpreted_string (self->priv->exiv2, tag);
	_tmp1_ = _tmp0_;
	_tmp2_ = prepare_input_text (_tmp1_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	result = _tmp3_;
	return result;
}


gchar* photo_metadata_get_first_string (PhotoMetadata* self, gchar** tags, int tags_length1) {
	gchar* result = NULL;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	{
		gchar** tag_collection;
		int tag_collection_length1;
		int tag_it;
		tag_collection = tags;
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			gchar* _tmp0_;
			gchar* tag;
			_tmp0_ = g_strdup (tag_collection[tag_it]);
			tag = _tmp0_;
			{
				gchar* _tmp1_ = NULL;
				gchar* value;
				_tmp1_ = photo_metadata_get_string (self, tag);
				value = _tmp1_;
				if (value != NULL) {
					result = value;
					_g_free0 (tag);
					return result;
				}
				_g_free0 (value);
				_g_free0 (tag);
			}
		}
	}
	result = NULL;
	return result;
}


gchar* photo_metadata_get_first_string_interpreted (PhotoMetadata* self, gchar** tags, int tags_length1) {
	gchar* result = NULL;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	{
		gchar** tag_collection;
		int tag_collection_length1;
		int tag_it;
		tag_collection = tags;
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			gchar* _tmp0_;
			gchar* tag;
			_tmp0_ = g_strdup (tag_collection[tag_it]);
			tag = _tmp0_;
			{
				gchar* _tmp1_ = NULL;
				gchar* value;
				_tmp1_ = photo_metadata_get_string_interpreted (self, tag);
				value = _tmp1_;
				if (value != NULL) {
					result = value;
					_g_free0 (tag);
					return result;
				}
				_g_free0 (value);
				_g_free0 (tag);
			}
		}
	}
	result = NULL;
	return result;
}


GeeList* photo_metadata_get_string_multiple (PhotoMetadata* self, const gchar* tag) {
	GeeList* result = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_ = NULL;
	gchar** values;
	gint values_length1;
	gint _values_size_;
	gboolean _tmp2_ = FALSE;
	GeeArrayList* _tmp3_ = NULL;
	GeeList* list;
	GeeHashSet* _tmp4_ = NULL;
	GeeHashSet* collection;
	GeeList* _tmp9_ = NULL;
	gint _tmp10_;
	GeeList* _tmp11_;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	g_return_val_if_fail (tag != NULL, NULL);
	_tmp1_ = _tmp0_ = gexiv2_metadata_get_tag_multiple (self->priv->exiv2, tag);
	values = _tmp1_;
	values_length1 = _vala_array_length (_tmp0_);
	_values_size_ = _vala_array_length (_tmp0_);
	if (values == NULL) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = values_length1 == 0;
	}
	if (_tmp2_) {
		result = NULL;
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	_tmp3_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
	list = GEE_LIST (_tmp3_);
	_tmp4_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL);
	collection = _tmp4_;
	{
		gchar** value_collection;
		int value_collection_length1;
		int value_it;
		value_collection = values;
		value_collection_length1 = values_length1;
		for (value_it = 0; value_it < values_length1; value_it = value_it + 1) {
			gchar* _tmp5_;
			gchar* value;
			_tmp5_ = g_strdup (value_collection[value_it]);
			value = _tmp5_;
			{
				gchar* _tmp6_ = NULL;
				gchar* prepped;
				gboolean _tmp7_ = FALSE;
				_tmp6_ = prepare_input_text (value, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
				prepped = _tmp6_;
				if (prepped != NULL) {
					gboolean _tmp8_;
					_tmp8_ = gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (collection), prepped);
					_tmp7_ = !_tmp8_;
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					gee_collection_add (GEE_COLLECTION (list), prepped);
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (collection), prepped);
				}
				_g_free0 (prepped);
				_g_free0 (value);
			}
		}
	}
	_tmp10_ = gee_collection_get_size (GEE_COLLECTION (list));
	if (_tmp10_ > 0) {
		_tmp9_ = list;
	} else {
		_tmp9_ = NULL;
	}
	_tmp11_ = _g_object_ref0 (_tmp9_);
	result = _tmp11_;
	_g_object_unref0 (collection);
	_g_object_unref0 (list);
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


GeeList* photo_metadata_get_first_string_multiple (PhotoMetadata* self, gchar** tags, int tags_length1) {
	GeeList* result = NULL;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	{
		gchar** tag_collection;
		int tag_collection_length1;
		int tag_it;
		tag_collection = tags;
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			gchar* _tmp0_;
			gchar* tag;
			_tmp0_ = g_strdup (tag_collection[tag_it]);
			tag = _tmp0_;
			{
				GeeList* _tmp1_ = NULL;
				GeeList* values;
				gboolean _tmp2_ = FALSE;
				_tmp1_ = photo_metadata_get_string_multiple (self, tag);
				values = _tmp1_;
				if (values != NULL) {
					gint _tmp3_;
					_tmp3_ = gee_collection_get_size (GEE_COLLECTION (values));
					_tmp2_ = _tmp3_ > 0;
				} else {
					_tmp2_ = FALSE;
				}
				if (_tmp2_) {
					result = values;
					_g_free0 (tag);
					return result;
				}
				_g_object_unref0 (values);
				_g_free0 (tag);
			}
		}
	}
	result = NULL;
	return result;
}


void photo_metadata_set_string (PhotoMetadata* self, const gchar* tag, const gchar* value) {
	gchar* _tmp0_ = NULL;
	gchar* prepped;
	gboolean _tmp1_;
	g_return_if_fail (IS_PHOTO_METADATA (self));
	g_return_if_fail (tag != NULL);
	g_return_if_fail (value != NULL);
	_tmp0_ = prepare_input_text (value, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
	prepped = _tmp0_;
	if (prepped == NULL) {
		g_warning ("PhotoMetadata.vala:392: Not setting tag %s to string %s: invalid UTF-8", tag, value);
		_g_free0 (prepped);
		return;
	}
	_tmp1_ = gexiv2_metadata_set_tag_string (self->priv->exiv2, tag, prepped);
	if (!_tmp1_) {
		g_warning ("PhotoMetadata.vala:398: Unable to set tag %s to string %s from source " \
"%s", tag, value, self->priv->source_name);
	}
	_g_free0 (prepped);
}


static void photo_metadata_set_all_generic (PhotoMetadata* self, gchar** tags, int tags_length1, PhotoMetadataSetOption option, PhotoMetadataSetGenericValue setter, void* setter_target) {
	gboolean written;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	g_return_if_fail (IS_PHOTO_METADATA (self));
	written = FALSE;
	{
		gchar** tag_collection;
		int tag_collection_length1;
		int tag_it;
		tag_collection = tags;
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			gchar* _tmp0_;
			gchar* tag;
			_tmp0_ = g_strdup (tag_collection[tag_it]);
			tag = _tmp0_;
			{
				gboolean _tmp1_ = FALSE;
				if (option == PHOTO_METADATA_SET_OPTION_ALL_DOMAINS) {
					_tmp1_ = TRUE;
				} else {
					MetadataDomain _tmp2_;
					gboolean _tmp3_;
					_tmp2_ = photo_metadata_get_tag_domain (tag);
					_tmp3_ = photo_metadata_has_domain (self, _tmp2_);
					_tmp1_ = _tmp3_;
				}
				if (_tmp1_) {
					setter (tag, setter_target);
					written = TRUE;
				}
				_g_free0 (tag);
			}
		}
	}
	if (option == PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN) {
		_tmp5_ = !written;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		_tmp4_ = tags_length1 > 0;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		MetadataDomain _tmp6_;
		MetadataDomain default_domain;
		_tmp6_ = photo_metadata_get_tag_domain (tags[0]);
		default_domain = _tmp6_;
		setter (tags[0], setter_target);
		{
			gint ctr;
			ctr = 1;
			{
				gboolean _tmp7_;
				_tmp7_ = TRUE;
				while (TRUE) {
					MetadataDomain _tmp8_;
					if (!_tmp7_) {
						ctr++;
					}
					_tmp7_ = FALSE;
					if (!(ctr < tags_length1)) {
						break;
					}
					_tmp8_ = photo_metadata_get_tag_domain (tags[ctr]);
					if (_tmp8_ == default_domain) {
						setter (tags[ctr], setter_target);
					}
				}
			}
		}
	}
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void block1_data_unref (Block1Data* _data1_) {
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		_media_metadata_unref0 (_data1_->self);
		_g_free0 (_data1_->value);
		g_slice_free (Block1Data, _data1_);
	}
}


static void _lambda1_ (const gchar* tag, Block1Data* _data1_) {
	PhotoMetadata * self;
	self = _data1_->self;
	g_return_if_fail (tag != NULL);
	photo_metadata_set_string (self, tag, _data1_->value);
}


static void __lambda1__photo_metadata_set_generic_value (const gchar* tag, gpointer self) {
	_lambda1_ (tag, self);
}


void photo_metadata_set_all_string (PhotoMetadata* self, gchar** tags, int tags_length1, const gchar* value, PhotoMetadataSetOption option) {
	Block1Data* _data1_;
	g_return_if_fail (IS_PHOTO_METADATA (self));
	g_return_if_fail (value != NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = media_metadata_ref (self);
	_data1_->value = g_strdup (value);
	photo_metadata_set_all_generic (self, tags, tags_length1, option, __lambda1__photo_metadata_set_generic_value, _data1_);
	block1_data_unref (_data1_);
	_data1_ = NULL;
}


static void _vala_array_add13 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add14 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


void photo_metadata_set_string_multiple (PhotoMetadata* self, const gchar* tag, GeeCollection* collection) {
	gchar** _tmp0_ = NULL;
	gchar** values;
	gint values_length1;
	gint _values_size_;
	gboolean _tmp6_;
	g_return_if_fail (IS_PHOTO_METADATA (self));
	g_return_if_fail (tag != NULL);
	g_return_if_fail (GEE_IS_COLLECTION (collection));
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	values = _tmp0_;
	values_length1 = 0;
	_values_size_ = 0;
	{
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _value_it;
		_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (collection));
		_value_it = _tmp1_;
		while (TRUE) {
			gboolean _tmp2_;
			gpointer _tmp3_ = NULL;
			gchar* value;
			gchar* _tmp4_ = NULL;
			gchar* prepped;
			_tmp2_ = gee_iterator_next (_value_it);
			if (!_tmp2_) {
				break;
			}
			_tmp3_ = gee_iterator_get (_value_it);
			value = (gchar*) _tmp3_;
			_tmp4_ = prepare_input_text (value, PHOTO_METADATA_PREPARE_STRING_OPTIONS, -1);
			prepped = _tmp4_;
			if (prepped != NULL) {
				gchar* _tmp5_;
				_tmp5_ = g_strdup (prepped);
				_vala_array_add13 (&values, &values_length1, &_values_size_, _tmp5_);
			} else {
				g_warning ("PhotoMetadata.vala:437: Unable to set string %s to %s: invalid UTF-8", value, tag);
			}
			_g_free0 (prepped);
			_g_free0 (value);
		}
		_g_object_unref0 (_value_it);
	}
	if (values_length1 == 0) {
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
		return;
	}
	_vala_array_add14 (&values, &values_length1, &_values_size_, NULL);
	_tmp6_ = gexiv2_metadata_set_tag_multiple (self->priv->exiv2, tag, values);
	if (!_tmp6_) {
		g_warning ("PhotoMetadata.vala:450: Unable to set %d strings to tag %s from source" \
" %s", values_length1, tag, self->priv->source_name);
	}
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
}


static Block2Data* block2_data_ref (Block2Data* _data2_) {
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}


static void block2_data_unref (Block2Data* _data2_) {
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		_media_metadata_unref0 (_data2_->self);
		_g_object_unref0 (_data2_->values);
		g_slice_free (Block2Data, _data2_);
	}
}


static void _lambda2_ (const gchar* tag, Block2Data* _data2_) {
	PhotoMetadata * self;
	self = _data2_->self;
	g_return_if_fail (tag != NULL);
	photo_metadata_set_string_multiple (self, tag, _data2_->values);
}


static void __lambda2__photo_metadata_set_generic_value (const gchar* tag, gpointer self) {
	_lambda2_ (tag, self);
}


void photo_metadata_set_all_string_multiple (PhotoMetadata* self, gchar** tags, int tags_length1, GeeCollection* values, PhotoMetadataSetOption option) {
	Block2Data* _data2_;
	g_return_if_fail (IS_PHOTO_METADATA (self));
	g_return_if_fail (GEE_IS_COLLECTION (values));
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = media_metadata_ref (self);
	_data2_->values = _g_object_ref0 (values);
	photo_metadata_set_all_generic (self, tags, tags_length1, option, __lambda2__photo_metadata_set_generic_value, _data2_);
	block2_data_unref (_data2_);
	_data2_ = NULL;
}


gboolean photo_metadata_get_long (PhotoMetadata* self, const gchar* tag, glong* value) {
	glong _value = 0L;
	gboolean result = FALSE;
	gboolean _tmp0_;
	glong _tmp1_;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
	g_return_val_if_fail (tag != NULL, FALSE);
	_tmp0_ = photo_metadata_has_tag (self, tag);
	if (!_tmp0_) {
		result = FALSE;
		if (value) {
			*value = _value;
		}
		return result;
	}
	_tmp1_ = gexiv2_metadata_get_tag_long (self->priv->exiv2, tag);
	_value = _tmp1_;
	result = TRUE;
	if (value) {
		*value = _value;
	}
	return result;
}


gboolean photo_metadata_get_first_long (PhotoMetadata* self, gchar** tags, int tags_length1, glong* value) {
	glong _value = 0L;
	gboolean result = FALSE;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
	{
		gchar** tag_collection;
		int tag_collection_length1;
		int tag_it;
		tag_collection = tags;
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			gchar* _tmp0_;
			gchar* tag;
			_tmp0_ = g_strdup (tag_collection[tag_it]);
			tag = _tmp0_;
			{
				glong _tmp1_;
				gboolean _tmp2_;
				_tmp2_ = photo_metadata_get_long (self, tag, &_tmp1_);
				_value = _tmp1_;
				if (_tmp2_) {
					result = TRUE;
					_g_free0 (tag);
					if (value) {
						*value = _value;
					}
					return result;
				}
				_g_free0 (tag);
			}
		}
	}
	result = FALSE;
	if (value) {
		*value = _value;
	}
	return result;
}


void photo_metadata_set_long (PhotoMetadata* self, const gchar* tag, glong value) {
	gboolean _tmp0_;
	g_return_if_fail (IS_PHOTO_METADATA (self));
	g_return_if_fail (tag != NULL);
	_tmp0_ = gexiv2_metadata_set_tag_long (self->priv->exiv2, tag, value);
	if (!_tmp0_) {
		g_warning ("PhotoMetadata.vala:477: Unable to set tag %s to long %ld from source %" \
"s", tag, value, self->priv->source_name);
	}
}


static Block3Data* block3_data_ref (Block3Data* _data3_) {
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}


static void block3_data_unref (Block3Data* _data3_) {
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		_media_metadata_unref0 (_data3_->self);
		g_slice_free (Block3Data, _data3_);
	}
}


static void _lambda3_ (const gchar* tag, Block3Data* _data3_) {
	PhotoMetadata * self;
	self = _data3_->self;
	g_return_if_fail (tag != NULL);
	photo_metadata_set_long (self, tag, _data3_->value);
}


static void __lambda3__photo_metadata_set_generic_value (const gchar* tag, gpointer self) {
	_lambda3_ (tag, self);
}


void photo_metadata_set_all_long (PhotoMetadata* self, gchar** tags, int tags_length1, glong value, PhotoMetadataSetOption option) {
	Block3Data* _data3_;
	g_return_if_fail (IS_PHOTO_METADATA (self));
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_data3_->self = media_metadata_ref (self);
	_data3_->value = value;
	photo_metadata_set_all_generic (self, tags, tags_length1, option, __lambda3__photo_metadata_set_generic_value, _data3_);
	block3_data_unref (_data3_);
	_data3_ = NULL;
}


gboolean photo_metadata_get_rational (PhotoMetadata* self, const gchar* tag, MetadataRational* rational) {
	MetadataRational _rational = {0};
	gboolean result = FALSE;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
	g_return_val_if_fail (tag != NULL, FALSE);
	_tmp2_ = gexiv2_metadata_get_exif_tag_rational (self->priv->exiv2, tag, &_tmp0_, &_tmp1_);
	_rational.numerator = _tmp0_;
	_rational.denominator = _tmp1_;
	result = _tmp2_;
	if (rational) {
		*rational = _rational;
	}
	return result;
}


gboolean photo_metadata_get_first_rational (PhotoMetadata* self, gchar** tags, int tags_length1, MetadataRational* rational) {
	MetadataRational _rational = {0};
	gboolean result = FALSE;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
	{
		gchar** tag_collection;
		int tag_collection_length1;
		int tag_it;
		tag_collection = tags;
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			gchar* _tmp0_;
			gchar* tag;
			_tmp0_ = g_strdup (tag_collection[tag_it]);
			tag = _tmp0_;
			{
				MetadataRational _tmp1_ = {0};
				gboolean _tmp2_;
				_tmp2_ = photo_metadata_get_rational (self, tag, &_tmp1_);
				_rational = _tmp1_;
				if (_tmp2_) {
					result = TRUE;
					_g_free0 (tag);
					if (rational) {
						*rational = _rational;
					}
					return result;
				}
				_g_free0 (tag);
			}
		}
	}
	result = FALSE;
	if (rational) {
		*rational = _rational;
	}
	return result;
}


void photo_metadata_set_rational (PhotoMetadata* self, const gchar* tag, MetadataRational* rational) {
	gboolean _tmp0_;
	g_return_if_fail (IS_PHOTO_METADATA (self));
	g_return_if_fail (tag != NULL);
	_tmp0_ = gexiv2_metadata_set_exif_tag_rational (self->priv->exiv2, tag, (*rational).numerator, (*rational).denominator);
	if (!_tmp0_) {
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		_tmp1_ = metadata_rational_to_string (rational);
		_tmp2_ = _tmp1_;
		g_warning ("PhotoMetadata.vala:499: Unable to set tag %s to rational %s from sourc" \
"e %s", tag, _tmp2_, self->priv->source_name);
		_g_free0 (_tmp2_);
	}
}


static Block4Data* block4_data_ref (Block4Data* _data4_) {
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}


static void block4_data_unref (Block4Data* _data4_) {
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		_media_metadata_unref0 (_data4_->self);
		g_slice_free (Block4Data, _data4_);
	}
}


static void _lambda4_ (const gchar* tag, Block4Data* _data4_) {
	PhotoMetadata * self;
	self = _data4_->self;
	g_return_if_fail (tag != NULL);
	photo_metadata_set_rational (self, tag, &_data4_->rational);
}


static void __lambda4__photo_metadata_set_generic_value (const gchar* tag, gpointer self) {
	_lambda4_ (tag, self);
}


void photo_metadata_set_all_rational (PhotoMetadata* self, gchar** tags, int tags_length1, MetadataRational* rational, PhotoMetadataSetOption option) {
	Block4Data* _data4_;
	g_return_if_fail (IS_PHOTO_METADATA (self));
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_data4_->self = media_metadata_ref (self);
	_data4_->rational = *rational;
	photo_metadata_set_all_generic (self, tags, tags_length1, option, __lambda4__photo_metadata_set_generic_value, _data4_);
	block4_data_unref (_data4_);
	_data4_ = NULL;
}


MetadataDateTime* photo_metadata_get_date_time (PhotoMetadata* self, const gchar* tag) {
	MetadataDateTime* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* value;
	MetadataDomain _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	g_return_val_if_fail (tag != NULL, NULL);
	_tmp0_ = photo_metadata_get_string (self, tag);
	value = _tmp0_;
	if (value == NULL) {
		result = NULL;
		_g_free0 (value);
		return result;
	}
	_tmp1_ = photo_metadata_get_tag_domain (tag);
	switch (_tmp1_) {
		case METADATA_DOMAIN_XMP:
		{
			MetadataDateTime* _tmp2_ = NULL;
			MetadataDateTime* _tmp3_;
			_tmp2_ = metadata_date_time_new_from_xmp (value, &_inner_error_);
			_tmp3_ = _tmp2_;
			if (_inner_error_ != NULL) {
				goto __catch23_g_error;
			}
			result = _tmp3_;
			_g_free0 (value);
			return result;
		}
		case METADATA_DOMAIN_IPTC:
		{
			result = NULL;
			_g_free0 (value);
			return result;
		}
		default:
		case METADATA_DOMAIN_EXIF:
		{
			MetadataDateTime* _tmp4_ = NULL;
			MetadataDateTime* _tmp5_;
			_tmp4_ = metadata_date_time_new_from_exif (value, &_inner_error_);
			_tmp5_ = _tmp4_;
			if (_inner_error_ != NULL) {
				goto __catch23_g_error;
			}
			result = _tmp5_;
			_g_free0 (value);
			return result;
		}
	}
	goto __finally23;
	__catch23_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		g_warning ("PhotoMetadata.vala:528: Unable to read date/time %s from source %s: %s", tag, self->priv->source_name, err->message);
		result = NULL;
		_g_error_free0 (err);
		_g_free0 (value);
		return result;
	}
	__finally23:
	_g_free0 (value);
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return NULL;
}


MetadataDateTime* photo_metadata_get_first_date_time (PhotoMetadata* self, gchar** tags, int tags_length1) {
	MetadataDateTime* result = NULL;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	{
		gchar** tag_collection;
		int tag_collection_length1;
		int tag_it;
		tag_collection = tags;
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			gchar* _tmp0_;
			gchar* tag;
			_tmp0_ = g_strdup (tag_collection[tag_it]);
			tag = _tmp0_;
			{
				MetadataDateTime* _tmp1_ = NULL;
				MetadataDateTime* date_time;
				_tmp1_ = photo_metadata_get_date_time (self, tag);
				date_time = _tmp1_;
				if (date_time != NULL) {
					result = date_time;
					_g_free0 (tag);
					return result;
				}
				_metadata_date_time_unref0 (date_time);
				_g_free0 (tag);
			}
		}
	}
	result = NULL;
	return result;
}


void photo_metadata_set_date_time (PhotoMetadata* self, const gchar* tag, MetadataDateTime* date_time) {
	MetadataDomain _tmp0_;
	g_return_if_fail (IS_PHOTO_METADATA (self));
	g_return_if_fail (tag != NULL);
	g_return_if_fail (IS_METADATA_DATE_TIME (date_time));
	_tmp0_ = photo_metadata_get_tag_domain (tag);
	switch (_tmp0_) {
		case METADATA_DOMAIN_EXIF:
		{
			gchar* _tmp1_ = NULL;
			gchar* _tmp2_;
			_tmp1_ = metadata_date_time_get_exif_label (date_time);
			_tmp2_ = _tmp1_;
			photo_metadata_set_string (self, tag, _tmp2_);
			_g_free0 (_tmp2_);
			break;
		}
		case METADATA_DOMAIN_XMP:
		{
			gchar* _tmp3_ = NULL;
			gchar* _tmp4_;
			_tmp3_ = metadata_date_time_get_xmp_label (date_time);
			_tmp4_ = _tmp3_;
			photo_metadata_set_string (self, tag, _tmp4_);
			_g_free0 (_tmp4_);
			break;
		}
		default:
		case METADATA_DOMAIN_IPTC:
		{
			MetadataDomain _tmp5_;
			GEnumValue* _tmp6_;
			_tmp5_ = photo_metadata_get_tag_domain (tag);
			_tmp6_ = g_enum_get_value (g_type_class_ref (TYPE_METADATA_DOMAIN), _tmp5_);
			g_warning ("PhotoMetadata.vala:557: Cannot set date/time for %s from source %s: un" \
"supported metadata domain %s", tag, self->priv->source_name, (_tmp6_ != NULL) ? _tmp6_->value_name : NULL);
			break;
		}
	}
}


static gpointer _metadata_date_time_ref0 (gpointer self) {
	return self ? metadata_date_time_ref (self) : NULL;
}


static Block5Data* block5_data_ref (Block5Data* _data5_) {
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}


static void block5_data_unref (Block5Data* _data5_) {
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		_media_metadata_unref0 (_data5_->self);
		_metadata_date_time_unref0 (_data5_->date_time);
		g_slice_free (Block5Data, _data5_);
	}
}


static void _lambda5_ (const gchar* tag, Block5Data* _data5_) {
	PhotoMetadata * self;
	self = _data5_->self;
	g_return_if_fail (tag != NULL);
	photo_metadata_set_date_time (self, tag, _data5_->date_time);
}


static void __lambda5__photo_metadata_set_generic_value (const gchar* tag, gpointer self) {
	_lambda5_ (tag, self);
}


void photo_metadata_set_all_date_time (PhotoMetadata* self, gchar** tags, int tags_length1, MetadataDateTime* date_time, PhotoMetadataSetOption option) {
	Block5Data* _data5_;
	g_return_if_fail (IS_PHOTO_METADATA (self));
	g_return_if_fail (IS_METADATA_DATE_TIME (date_time));
	_data5_ = g_slice_new0 (Block5Data);
	_data5_->_ref_count_ = 1;
	_data5_->self = media_metadata_ref (self);
	_data5_->date_time = _metadata_date_time_ref0 (date_time);
	photo_metadata_set_all_generic (self, tags, tags_length1, option, __lambda5__photo_metadata_set_generic_value, _data5_);
	block5_data_unref (_data5_);
	_data5_ = NULL;
}


guint8* photo_metadata_flatten_exif (PhotoMetadata* self, gboolean include_preview, int* result_length1) {
	guint8* result = NULL;
	guchar* thumbnail;
	guint thumbnail_size;
	guint8* flattened;
	gint flattened_length1;
	gint _flattened_size_;
	guchar* saved_data;
	guint saved_size;
	gboolean _tmp1_ = FALSE;
	guint8* _tmp5_;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	if (self->priv->exif == NULL) {
		gpointer _tmp0_;
		_tmp0_ = NULL;
		*result_length1 = 0;
		result = _tmp0_;
		return result;
	}
	thumbnail = self->priv->exif->data;
	thumbnail_size = self->priv->exif->size;
	if (!include_preview) {
		self->priv->exif->data = NULL;
		self->priv->exif->size = (guint) 0;
	}
	flattened = NULL;
	flattened_length1 = 0;
	_flattened_size_ = 0;
	saved_data = NULL;
	saved_size = (guint) 0;
	exif_data_save_data (self->priv->exif, &saved_data, &saved_size);
	if (saved_size > 0) {
		_tmp1_ = saved_data != NULL;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		guint8* _tmp2_ = NULL;
		ExifMem* _tmp3_ = NULL;
		ExifMem* _tmp4_;
		_tmp2_ = g_new0 (guint8, saved_size);
		flattened = (g_free (flattened), NULL);
		flattened = _tmp2_;
		flattened_length1 = saved_size;
		_flattened_size_ = saved_size;
		memcpy (flattened, saved_data, (gsize) saved_size);
		_tmp3_ = exif_mem_new_default ();
		_tmp4_ = _tmp3_;
		exif_mem_free (_tmp4_, saved_data);
		_exif_mem_unref0 (_tmp4_);
	}
	self->priv->exif->data = thumbnail;
	self->priv->exif->size = thumbnail_size;
	_tmp5_ = flattened;
	*result_length1 = flattened_length1;
	result = _tmp5_;
	return result;
}


static guint8* _vala_array_dup9 (guint8* self, int length) {
	return g_memdup (self, length * sizeof (guint8));
}


guint8* photo_metadata_flatten_exif_preview (PhotoMetadata* self, int* result_length1) {
	guint8* result = NULL;
	guchar* buffer = NULL;
	gint buffer_length1 = 0;
	gint _buffer_size_ = 0;
	guchar* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint __tmp0__size_ = 0;
	guchar* _tmp1_ = NULL;
	gint _tmp2_;
	gboolean _tmp3_;
	guint8* _tmp4_;
	guint8* _tmp5_;
	guchar* _tmp6_;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	_tmp3_ = gexiv2_metadata_get_exif_thumbnail (self->priv->exiv2, &_tmp1_, &_tmp2_);
	buffer = (g_free (buffer), NULL);
	buffer = _tmp1_;
	buffer_length1 = _tmp2_;
	if (_tmp3_) {
		_tmp0_ = buffer;
		_tmp0__length1 = buffer_length1;
		__tmp0__size_ = buffer_length1;
	} else {
		_tmp0_ = NULL;
		_tmp0__length1 = 0;
		__tmp0__size_ = 0;
	}
	_tmp4_ = (_tmp5_ = _tmp0_, (_tmp5_ == NULL) ? ((gpointer) _tmp5_) : _vala_array_dup9 (_tmp5_, _tmp0__length1));
	_tmp6_ = _tmp4_;
	*result_length1 = _tmp0__length1;
	result = _tmp6_;
	buffer = (g_free (buffer), NULL);
	return result;
}


guint photo_metadata_get_preview_count (PhotoMetadata* self) {
	guint result = 0U;
	GExiv2PreviewProperties** _tmp0_;
	GExiv2PreviewProperties** _tmp1_ = NULL;
	GExiv2PreviewProperties** props;
	gint props_length1;
	gint _props_size_;
	gint _tmp2_ = 0;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), 0U);
	_tmp1_ = _tmp0_ = gexiv2_metadata_get_preview_properties (self->priv->exiv2);
	props = _tmp1_;
	props_length1 = _vala_array_length (_tmp0_);
	_props_size_ = _vala_array_length (_tmp0_);
	if (props != NULL) {
		_tmp2_ = props_length1;
	} else {
		_tmp2_ = 0;
	}
	result = (guint) _tmp2_;
	return result;
}


PhotoPreview* photo_metadata_get_preview (PhotoMetadata* self, guint number) {
	PhotoPreview* result = NULL;
	GExiv2PreviewProperties** _tmp0_;
	GExiv2PreviewProperties** _tmp1_ = NULL;
	GExiv2PreviewProperties** props;
	gint props_length1;
	gint _props_size_;
	gboolean _tmp2_ = FALSE;
	PhotoMetadataInternalPhotoPreview* _tmp3_ = NULL;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	_tmp1_ = _tmp0_ = gexiv2_metadata_get_preview_properties (self->priv->exiv2);
	props = _tmp1_;
	props_length1 = _vala_array_length (_tmp0_);
	_props_size_ = _vala_array_length (_tmp0_);
	if (props == NULL) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = props_length1 <= number;
	}
	if (_tmp2_) {
		result = NULL;
		return result;
	}
	_tmp3_ = photo_metadata_internal_photo_preview_new (self, self->priv->source_name, number, props[number]);
	result = PHOTO_PREVIEW (_tmp3_);
	return result;
}


void photo_metadata_remove_exif_thumbnail (PhotoMetadata* self) {
	g_return_if_fail (IS_PHOTO_METADATA (self));
	gexiv2_metadata_erase_exif_thumbnail (self->priv->exiv2);
	if (self->priv->exif != NULL) {
		ExifMem* _tmp0_ = NULL;
		ExifMem* _tmp1_;
		_tmp0_ = exif_mem_new_default ();
		_tmp1_ = _tmp0_;
		exif_mem_free (_tmp1_, self->priv->exif->data);
		_exif_mem_unref0 (_tmp1_);
		self->priv->exif->data = NULL;
		self->priv->exif->size = (guint) 0;
	}
}


void photo_metadata_remove_tag (PhotoMetadata* self, const gchar* tag) {
	g_return_if_fail (IS_PHOTO_METADATA (self));
	g_return_if_fail (tag != NULL);
	gexiv2_metadata_clear_tag (self->priv->exiv2, tag);
}


void photo_metadata_remove_tags (PhotoMetadata* self, gchar** tags, int tags_length1) {
	g_return_if_fail (IS_PHOTO_METADATA (self));
	{
		gchar** tag_collection;
		int tag_collection_length1;
		int tag_it;
		tag_collection = tags;
		tag_collection_length1 = tags_length1;
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
			gchar* _tmp0_;
			gchar* tag;
			_tmp0_ = g_strdup (tag_collection[tag_it]);
			tag = _tmp0_;
			{
				photo_metadata_remove_tag (self, tag);
				_g_free0 (tag);
			}
		}
	}
}


void photo_metadata_clear_domain (PhotoMetadata* self, MetadataDomain domain) {
	g_return_if_fail (IS_PHOTO_METADATA (self));
	switch (domain) {
		case METADATA_DOMAIN_EXIF:
		{
			gexiv2_metadata_clear_exif (self->priv->exiv2);
			break;
		}
		case METADATA_DOMAIN_XMP:
		{
			gexiv2_metadata_clear_xmp (self->priv->exiv2);
			break;
		}
		case METADATA_DOMAIN_IPTC:
		{
			gexiv2_metadata_clear_iptc (self->priv->exiv2);
			break;
		}
		default:
		break;
	}
}


void photo_metadata_clear (PhotoMetadata* self) {
	g_return_if_fail (IS_PHOTO_METADATA (self));
	gexiv2_metadata_clear (self->priv->exiv2);
}


MetadataDateTime* photo_metadata_get_modification_date_time (PhotoMetadata* self) {
	MetadataDateTime* result = NULL;
	MetadataDateTime* _tmp0_ = NULL;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	_tmp0_ = photo_metadata_get_first_date_time (self, photo_metadata_DATE_TIME_TAGS, photo_metadata_DATE_TIME_TAGS_length1);
	result = _tmp0_;
	return result;
}


void photo_metadata_set_modification_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option) {
	g_return_if_fail (IS_PHOTO_METADATA (self));
	g_return_if_fail ((date_time == NULL) || IS_METADATA_DATE_TIME (date_time));
	if (date_time != NULL) {
		photo_metadata_set_all_date_time (self, photo_metadata_DATE_TIME_TAGS, photo_metadata_DATE_TIME_TAGS_length1, date_time, option);
	} else {
		photo_metadata_remove_tags (self, photo_metadata_DATE_TIME_TAGS, photo_metadata_DATE_TIME_TAGS_length1);
	}
}


MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self) {
	MetadataDateTime* result = NULL;
	MetadataDateTime* _tmp0_ = NULL;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	_tmp0_ = photo_metadata_get_first_date_time (self, photo_metadata_EXPOSURE_DATE_TIME_TAGS, photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1);
	result = _tmp0_;
	return result;
}


void photo_metadata_set_exposure_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option) {
	g_return_if_fail (IS_PHOTO_METADATA (self));
	g_return_if_fail ((date_time == NULL) || IS_METADATA_DATE_TIME (date_time));
	if (date_time != NULL) {
		photo_metadata_set_all_date_time (self, photo_metadata_EXPOSURE_DATE_TIME_TAGS, photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1, date_time, option);
	} else {
		photo_metadata_remove_tags (self, photo_metadata_EXPOSURE_DATE_TIME_TAGS, photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1);
	}
}


MetadataDateTime* photo_metadata_get_digitized_date_time (PhotoMetadata* self) {
	MetadataDateTime* result = NULL;
	MetadataDateTime* _tmp0_ = NULL;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	_tmp0_ = photo_metadata_get_first_date_time (self, photo_metadata_DIGITIZED_DATE_TIME_TAGS, photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1);
	result = _tmp0_;
	return result;
}


void photo_metadata_set_digitized_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option) {
	g_return_if_fail (IS_PHOTO_METADATA (self));
	g_return_if_fail ((date_time == NULL) || IS_METADATA_DATE_TIME (date_time));
	if (date_time != NULL) {
		photo_metadata_set_all_date_time (self, photo_metadata_DIGITIZED_DATE_TIME_TAGS, photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1, date_time, option);
	} else {
		photo_metadata_remove_tags (self, photo_metadata_DIGITIZED_DATE_TIME_TAGS, photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1);
	}
}


static MetadataDateTime* photo_metadata_real_get_creation_date_time (MediaMetadata* base) {
	PhotoMetadata * self;
	MetadataDateTime* result = NULL;
	MetadataDateTime* _tmp0_ = NULL;
	MetadataDateTime* creation;
	self = PHOTO_METADATA (base);
	_tmp0_ = photo_metadata_get_exposure_date_time (self);
	creation = _tmp0_;
	if (creation == NULL) {
		MetadataDateTime* _tmp1_ = NULL;
		_tmp1_ = photo_metadata_get_digitized_date_time (self);
		_metadata_date_time_unref0 (creation);
		creation = _tmp1_;
	}
	result = creation;
	return result;
}


static gpointer _dimensions_dup0 (gpointer self) {
	return self ? dimensions_dup (self) : NULL;
}


Dimensions* photo_metadata_get_pixel_dimensions (PhotoMetadata* self) {
	Dimensions* result = NULL;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	g_assert (photo_metadata_WIDTH_TAGS_length1 == photo_metadata_HEIGHT_TAGS_length1);
	{
		gint ctr;
		ctr = 0;
		{
			gboolean _tmp0_;
			_tmp0_ = TRUE;
			while (TRUE) {
				glong width = 0L;
				glong _tmp1_;
				gboolean _tmp2_;
				glong height = 0L;
				glong _tmp3_;
				gboolean _tmp4_;
				Dimensions _tmp5_ = {0};
				Dimensions _tmp6_ = {0};
				Dimensions* _tmp7_;
				if (!_tmp0_) {
					ctr++;
				}
				_tmp0_ = FALSE;
				if (!(ctr < photo_metadata_WIDTH_TAGS_length1)) {
					break;
				}
				_tmp2_ = photo_metadata_get_long (self, photo_metadata_WIDTH_TAGS[ctr], &_tmp1_);
				width = _tmp1_;
				if (!_tmp2_) {
					continue;
				}
				_tmp4_ = photo_metadata_get_long (self, photo_metadata_HEIGHT_TAGS[ctr], &_tmp3_);
				height = _tmp3_;
				if (!_tmp4_) {
					continue;
				}
				dimensions_init (&_tmp5_, (gint) width, (gint) height);
				_tmp6_ = _tmp5_;
				_tmp7_ = _dimensions_dup0 (&_tmp6_);
				result = _tmp7_;
				return result;
			}
		}
	}
	result = NULL;
	return result;
}


void photo_metadata_set_pixel_dimensions (PhotoMetadata* self, Dimensions* dim, PhotoMetadataSetOption option) {
	g_return_if_fail (IS_PHOTO_METADATA (self));
	if (dim != NULL) {
		photo_metadata_set_all_long (self, photo_metadata_WIDTH_TAGS, photo_metadata_WIDTH_TAGS_length1, (glong) (*dim).width, option);
		photo_metadata_set_all_long (self, photo_metadata_HEIGHT_TAGS, photo_metadata_HEIGHT_TAGS_length1, (glong) (*dim).height, option);
	} else {
		photo_metadata_remove_tags (self, photo_metadata_WIDTH_TAGS, photo_metadata_WIDTH_TAGS_length1);
		photo_metadata_remove_tags (self, photo_metadata_HEIGHT_TAGS, photo_metadata_HEIGHT_TAGS_length1);
	}
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _result_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}


static gchar* photo_metadata_real_get_title (MediaMetadata* base) {
	PhotoMetadata * self;
	gchar* result = NULL;
	GeeList* _tmp0_ = NULL;
	gboolean _tmp1_;
	GeeList* _tmp4_;
	GeeList* titles;
	gchar* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	gchar* _tmp9_;
	gchar* title;
	const gchar* _tmp11_ = NULL;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_;
	gchar* _tmp17_;
	self = PHOTO_METADATA (base);
	_tmp1_ = photo_metadata_has_tag (self, PHOTO_METADATA_IPHOTO_TITLE_TAG);
	if (_tmp1_) {
		GeeList* _tmp2_ = NULL;
		_tmp2_ = photo_metadata_get_string_multiple (self, PHOTO_METADATA_IPHOTO_TITLE_TAG);
		_g_object_unref0 (_tmp0_);
		_tmp0_ = _tmp2_;
	} else {
		GeeList* _tmp3_ = NULL;
		_tmp3_ = photo_metadata_get_first_string_multiple (self, photo_metadata_STANDARD_TITLE_TAGS, photo_metadata_STANDARD_TITLE_TAGS_length1);
		_g_object_unref0 (_tmp0_);
		_tmp0_ = _tmp3_;
	}
	_tmp4_ = _g_object_ref0 (_tmp0_);
	titles = _tmp4_;
	if (titles != NULL) {
		gint _tmp7_;
		_tmp7_ = gee_collection_get_size (GEE_COLLECTION (titles));
		_tmp6_ = _tmp7_ > 0;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		gpointer _tmp8_ = NULL;
		_tmp8_ = gee_list_get (titles, 0);
		_g_free0 (_tmp5_);
		_tmp5_ = (gchar*) _tmp8_;
	} else {
		_g_free0 (_tmp5_);
		_tmp5_ = NULL;
	}
	_tmp9_ = g_strdup (_tmp5_);
	title = _tmp9_;
	if (title != NULL) {
		gchar* _tmp10_ = NULL;
		_tmp10_ = string_strip (title);
		_g_free0 (title);
		title = _tmp10_;
	}
	_tmp14_ = is_string_empty (title);
	if (!_tmp14_) {
		gboolean _tmp15_;
		_tmp15_ = string_contains (title, "\n");
		_tmp13_ = !_tmp15_;
	} else {
		_tmp13_ = FALSE;
	}
	if (_tmp13_) {
		gboolean _tmp16_;
		_tmp16_ = string_contains (title, "\r");
		_tmp12_ = !_tmp16_;
	} else {
		_tmp12_ = FALSE;
	}
	if (_tmp12_) {
		_tmp11_ = title;
	} else {
		_tmp11_ = NULL;
	}
	_tmp17_ = g_strdup (_tmp11_);
	result = _tmp17_;
	_g_free0 (title);
	_g_free0 (_tmp5_);
	_g_object_unref0 (titles);
	_g_object_unref0 (_tmp0_);
	return result;
}


void photo_metadata_set_title (PhotoMetadata* self, const gchar* title, PhotoMetadataSetOption option) {
	gboolean _tmp0_;
	g_return_if_fail (IS_PHOTO_METADATA (self));
	_tmp0_ = is_string_empty (title);
	if (!_tmp0_) {
		gboolean _tmp1_;
		_tmp1_ = photo_metadata_has_tag (self, PHOTO_METADATA_IPHOTO_TITLE_TAG);
		if (_tmp1_) {
			photo_metadata_set_string (self, PHOTO_METADATA_IPHOTO_TITLE_TAG, title);
		} else {
			photo_metadata_set_all_string (self, photo_metadata_STANDARD_TITLE_TAGS, photo_metadata_STANDARD_TITLE_TAGS_length1, title, option);
		}
	} else {
		photo_metadata_remove_tags (self, photo_metadata_STANDARD_TITLE_TAGS, photo_metadata_STANDARD_TITLE_TAGS_length1);
	}
}


GeeSet* photo_metadata_get_keywords (PhotoMetadata* self, GCompareFunc compare_func) {
	GeeSet* result = NULL;
	GeeSet* keywords;
	GeeSet* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	GeeSet* _tmp13_;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	keywords = NULL;
	{
		gchar** tag_collection;
		int tag_collection_length1;
		int tag_it;
		tag_collection = photo_metadata_KEYWORD_TAGS;
		tag_collection_length1 = photo_metadata_KEYWORD_TAGS_length1;
		for (tag_it = 0; tag_it < photo_metadata_KEYWORD_TAGS_length1; tag_it = tag_it + 1) {
			gchar* _tmp0_;
			gchar* tag;
			_tmp0_ = g_strdup (tag_collection[tag_it]);
			tag = _tmp0_;
			{
				GeeList* _tmp1_ = NULL;
				GeeCollection* values;
				gboolean _tmp2_ = FALSE;
				_tmp1_ = photo_metadata_get_string_multiple (self, tag);
				values = GEE_COLLECTION (_tmp1_);
				if (values != NULL) {
					gint _tmp3_;
					_tmp3_ = gee_collection_get_size (values);
					_tmp2_ = _tmp3_ > 0;
				} else {
					_tmp2_ = FALSE;
				}
				if (_tmp2_) {
					if (keywords == NULL) {
						GeeSet* _tmp4_ = NULL;
						_tmp4_ = photo_metadata_create_string_set (self, compare_func);
						_g_object_unref0 (keywords);
						keywords = _tmp4_;
					}
					{
						GeeIterator* _tmp5_ = NULL;
						GeeIterator* _current_value_it;
						_tmp5_ = gee_iterable_iterator (GEE_ITERABLE (values));
						_current_value_it = _tmp5_;
						while (TRUE) {
							gboolean _tmp6_;
							gpointer _tmp7_ = NULL;
							gchar* current_value;
							gchar* _tmp8_ = NULL;
							gchar* _tmp9_;
							_tmp6_ = gee_iterator_next (_current_value_it);
							if (!_tmp6_) {
								break;
							}
							_tmp7_ = gee_iterator_get (_current_value_it);
							current_value = (gchar*) _tmp7_;
							_tmp8_ = hierarchical_tag_utilities_make_flat_tag_safe (current_value);
							_tmp9_ = _tmp8_;
							gee_collection_add (GEE_COLLECTION (keywords), _tmp9_);
							_g_free0 (_tmp9_);
							_g_free0 (current_value);
						}
						_g_object_unref0 (_current_value_it);
					}
				}
				_g_object_unref0 (values);
				_g_free0 (tag);
			}
		}
	}
	if (keywords != NULL) {
		gint _tmp12_;
		_tmp12_ = gee_collection_get_size (GEE_COLLECTION (keywords));
		_tmp11_ = _tmp12_ > 0;
	} else {
		_tmp11_ = FALSE;
	}
	if (_tmp11_) {
		_tmp10_ = keywords;
	} else {
		_tmp10_ = NULL;
	}
	_tmp13_ = _g_object_ref0 (_tmp10_);
	result = _tmp13_;
	_g_object_unref0 (keywords);
	return result;
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	GRegex* _tmp2_ = NULL;
	GRegex* _tmp3_;
	GRegex* regex;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	_tmp0_ = g_regex_escape_string (old, -1);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_regex_new (_tmp1_, 0, 0, &_inner_error_);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	regex = _tmp3_;
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_REGEX_ERROR) {
			goto __catch24_g_regex_error;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp4_ = g_regex_replace_literal (regex, self, (gssize) (-1), 0, replacement, 0, &_inner_error_);
	_tmp5_ = _tmp4_;
	if (_inner_error_ != NULL) {
		_g_regex_unref0 (regex);
		if (_inner_error_->domain == G_REGEX_ERROR) {
			goto __catch24_g_regex_error;
		}
		_g_regex_unref0 (regex);
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = _tmp5_;
	_g_regex_unref0 (regex);
	return result;
	_g_regex_unref0 (regex);
	goto __finally24;
	__catch24_g_regex_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally24:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* _tmp0_ = NULL;
	gchar* end;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	if (end == NULL) {
		result = maxlen;
		return result;
	} else {
		result = (glong) (end - str);
		return result;
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= 0) {
		_tmp0_ = len >= 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		glong _tmp1_;
		_tmp1_ = string_strnlen ((gchar*) self, offset + len);
		string_length = _tmp1_;
	} else {
		gint _tmp2_;
		_tmp2_ = strlen (self);
		string_length = (glong) _tmp2_;
	}
	if (offset < 0) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= 0, NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < 0) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp3_;
	return result;
}


static void photo_metadata_internal_set_hierarchical_keywords (PhotoMetadata* self, HierarchicalTagIndex* index) {
	g_return_if_fail (IS_PHOTO_METADATA (self));
	g_return_if_fail ((index == NULL) || IS_HIERARCHICAL_TAG_INDEX (index));
	{
		HierarchicalKeywordField* current_field_collection;
		int current_field_collection_length1;
		int current_field_it;
		current_field_collection = photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
		current_field_collection_length1 = photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
		for (current_field_it = 0; current_field_it < photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1; current_field_it = current_field_it + 1) {
			HierarchicalKeywordField _tmp0_;
			HierarchicalKeywordField _tmp1_ = {0};
			HierarchicalKeywordField current_field;
			hierarchical_keyword_field_copy (&current_field_collection[current_field_it], &_tmp1_);
			_tmp0_ = _tmp1_;
			current_field = _tmp0_;
			{
				photo_metadata_remove_tag (self, current_field.field_name);
				hierarchical_keyword_field_destroy (&current_field);
			}
		}
	}
	if (index == NULL) {
		return;
	}
	{
		HierarchicalKeywordField* current_field_collection;
		int current_field_collection_length1;
		int current_field_it;
		current_field_collection = photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
		current_field_collection_length1 = photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
		for (current_field_it = 0; current_field_it < photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1; current_field_it = current_field_it + 1) {
			HierarchicalKeywordField _tmp2_;
			HierarchicalKeywordField _tmp3_ = {0};
			HierarchicalKeywordField current_field;
			hierarchical_keyword_field_copy (&current_field_collection[current_field_it], &_tmp3_);
			_tmp2_ = _tmp3_;
			current_field = _tmp2_;
			{
				GeeTreeSet* _tmp4_ = NULL;
				GeeSet* writeable_set;
				if (!current_field.is_writeable) {
					hierarchical_keyword_field_destroy (&current_field);
					continue;
				}
				_tmp4_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
				writeable_set = GEE_SET (_tmp4_);
				{
					GeeCollection* _tmp5_ = NULL;
					GeeCollection* _tmp6_;
					GeeIterator* _tmp7_ = NULL;
					GeeIterator* _tmp8_;
					GeeIterator* _current_path_it;
					_tmp5_ = hierarchical_tag_index_get_all_paths (index);
					_tmp6_ = _tmp5_;
					_tmp7_ = gee_iterable_iterator (GEE_ITERABLE (_tmp6_));
					_tmp8_ = _tmp7_;
					_g_object_unref0 (_tmp6_);
					_current_path_it = _tmp8_;
					while (TRUE) {
						gboolean _tmp9_;
						gpointer _tmp10_ = NULL;
						gchar* current_path;
						gchar* _tmp11_ = NULL;
						gchar* writeable_path;
						_tmp9_ = gee_iterator_next (_current_path_it);
						if (!_tmp9_) {
							break;
						}
						_tmp10_ = gee_iterator_get (_current_path_it);
						current_path = (gchar*) _tmp10_;
						_tmp11_ = string_replace (current_path, TAG_PATH_SEPARATOR_STRING, current_field.path_separator);
						writeable_path = _tmp11_;
						if (!current_field.wants_leading_separator) {
							gchar* _tmp12_ = NULL;
							_tmp12_ = string_substring (writeable_path, (glong) 1, (glong) (-1));
							_g_free0 (writeable_path);
							writeable_path = _tmp12_;
						}
						gee_collection_add (GEE_COLLECTION (writeable_set), writeable_path);
						_g_free0 (writeable_path);
						_g_free0 (current_path);
					}
					_g_object_unref0 (_current_path_it);
				}
				photo_metadata_set_string_multiple (self, current_field.field_name, GEE_COLLECTION (writeable_set));
				_g_object_unref0 (writeable_set);
				hierarchical_keyword_field_destroy (&current_field);
			}
		}
	}
}


void photo_metadata_set_keywords (PhotoMetadata* self, GeeCollection* keywords, PhotoMetadataSetOption option) {
	HierarchicalTagIndex* _tmp0_ = NULL;
	HierarchicalTagIndex* htag_index;
	GeeTreeSet* _tmp1_ = NULL;
	GeeSet* flat_keywords;
	g_return_if_fail (IS_PHOTO_METADATA (self));
	g_return_if_fail ((keywords == NULL) || GEE_IS_COLLECTION (keywords));
	_tmp0_ = hierarchical_tag_index_new ();
	htag_index = _tmp0_;
	_tmp1_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
	flat_keywords = GEE_SET (_tmp1_);
	if (keywords != NULL) {
		GeeCollection* _tmp10_ = NULL;
		GeeCollection* _tmp11_;
		{
			GeeIterator* _tmp2_ = NULL;
			GeeIterator* _keyword_it;
			_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (keywords));
			_keyword_it = _tmp2_;
			while (TRUE) {
				gboolean _tmp3_;
				gpointer _tmp4_ = NULL;
				gchar* keyword;
				gboolean _tmp5_;
				_tmp3_ = gee_iterator_next (_keyword_it);
				if (!_tmp3_) {
					break;
				}
				_tmp4_ = gee_iterator_get (_keyword_it);
				keyword = (gchar*) _tmp4_;
				_tmp5_ = g_str_has_prefix (keyword, TAG_PATH_SEPARATOR_STRING);
				if (_tmp5_) {
					GeeList* _tmp6_ = NULL;
					GeeCollection* path_components;
					_tmp6_ = hierarchical_tag_utilities_enumerate_path_components (keyword);
					path_components = GEE_COLLECTION (_tmp6_);
					{
						GeeIterator* _tmp7_ = NULL;
						GeeIterator* _component_it;
						_tmp7_ = gee_iterable_iterator (GEE_ITERABLE (path_components));
						_component_it = _tmp7_;
						while (TRUE) {
							gboolean _tmp8_;
							gpointer _tmp9_ = NULL;
							gchar* component;
							_tmp8_ = gee_iterator_next (_component_it);
							if (!_tmp8_) {
								break;
							}
							_tmp9_ = gee_iterator_get (_component_it);
							component = (gchar*) _tmp9_;
							hierarchical_tag_index_add_path (htag_index, component, keyword);
							_g_free0 (component);
						}
						_g_object_unref0 (_component_it);
					}
					_g_object_unref0 (path_components);
				} else {
					gee_collection_add (GEE_COLLECTION (flat_keywords), keyword);
				}
				_g_free0 (keyword);
			}
			_g_object_unref0 (_keyword_it);
		}
		_tmp10_ = hierarchical_tag_index_get_all_tags (htag_index);
		_tmp11_ = _tmp10_;
		gee_collection_add_all (GEE_COLLECTION (flat_keywords), _tmp11_);
		_g_object_unref0 (_tmp11_);
	}
	if (keywords != NULL) {
		photo_metadata_set_all_string_multiple (self, photo_metadata_KEYWORD_TAGS, photo_metadata_KEYWORD_TAGS_length1, GEE_COLLECTION (flat_keywords), option);
		photo_metadata_internal_set_hierarchical_keywords (self, htag_index);
	} else {
		photo_metadata_remove_tags (self, photo_metadata_KEYWORD_TAGS, photo_metadata_KEYWORD_TAGS_length1);
		photo_metadata_internal_set_hierarchical_keywords (self, NULL);
	}
	_g_object_unref0 (flat_keywords);
	_hierarchical_tag_index_unref0 (htag_index);
}


gboolean photo_metadata_has_hierarchical_keywords (PhotoMetadata* self) {
	gboolean result = FALSE;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
	{
		HierarchicalKeywordField* field_collection;
		int field_collection_length1;
		int field_it;
		field_collection = photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
		field_collection_length1 = photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
		for (field_it = 0; field_it < photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1; field_it = field_it + 1) {
			HierarchicalKeywordField _tmp0_;
			HierarchicalKeywordField _tmp1_ = {0};
			HierarchicalKeywordField field;
			hierarchical_keyword_field_copy (&field_collection[field_it], &_tmp1_);
			_tmp0_ = _tmp1_;
			field = _tmp0_;
			{
				GeeList* _tmp2_ = NULL;
				GeeCollection* values;
				gboolean _tmp3_ = FALSE;
				_tmp2_ = photo_metadata_get_string_multiple (self, field.field_name);
				values = GEE_COLLECTION (_tmp2_);
				if (values != NULL) {
					gint _tmp4_;
					_tmp4_ = gee_collection_get_size (values);
					_tmp3_ = _tmp4_ > 0;
				} else {
					_tmp3_ = FALSE;
				}
				if (_tmp3_) {
					result = TRUE;
					_g_object_unref0 (values);
					hierarchical_keyword_field_destroy (&field);
					return result;
				}
				_g_object_unref0 (values);
				hierarchical_keyword_field_destroy (&field);
			}
		}
	}
	result = FALSE;
	return result;
}


GeeSet* photo_metadata_get_hierarchical_keywords (PhotoMetadata* self) {
	GeeSet* result = NULL;
	gboolean _tmp0_;
	GeeSet* _tmp1_ = NULL;
	GeeSet* h_keywords;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	_tmp0_ = photo_metadata_has_hierarchical_keywords (self);
	g_assert (_tmp0_);
	_tmp1_ = photo_metadata_create_string_set (self, NULL);
	h_keywords = _tmp1_;
	{
		HierarchicalKeywordField* field_collection;
		int field_collection_length1;
		int field_it;
		field_collection = photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
		field_collection_length1 = photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
		for (field_it = 0; field_it < photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1; field_it = field_it + 1) {
			HierarchicalKeywordField _tmp2_;
			HierarchicalKeywordField _tmp3_ = {0};
			HierarchicalKeywordField field;
			hierarchical_keyword_field_copy (&field_collection[field_it], &_tmp3_);
			_tmp2_ = _tmp3_;
			field = _tmp2_;
			{
				GeeList* _tmp4_ = NULL;
				GeeCollection* values;
				gboolean _tmp5_ = FALSE;
				_tmp4_ = photo_metadata_get_string_multiple (self, field.field_name);
				values = GEE_COLLECTION (_tmp4_);
				if (values == NULL) {
					_tmp5_ = TRUE;
				} else {
					gint _tmp6_;
					_tmp6_ = gee_collection_get_size (values);
					_tmp5_ = _tmp6_ < 1;
				}
				if (_tmp5_) {
					_g_object_unref0 (values);
					hierarchical_keyword_field_destroy (&field);
					continue;
				}
				{
					GeeIterator* _tmp7_ = NULL;
					GeeIterator* _current_value_it;
					_tmp7_ = gee_iterable_iterator (GEE_ITERABLE (values));
					_current_value_it = _tmp7_;
					while (TRUE) {
						gboolean _tmp8_;
						gpointer _tmp9_ = NULL;
						gchar* current_value;
						gchar* _tmp10_ = NULL;
						gchar* canonicalized;
						_tmp8_ = gee_iterator_next (_current_value_it);
						if (!_tmp8_) {
							break;
						}
						_tmp9_ = gee_iterator_get (_current_value_it);
						current_value = (gchar*) _tmp9_;
						_tmp10_ = hierarchical_tag_utilities_canonicalize (current_value, field.path_separator);
						canonicalized = _tmp10_;
						if (canonicalized != NULL) {
							gee_collection_add (GEE_COLLECTION (h_keywords), canonicalized);
						}
						_g_free0 (canonicalized);
						_g_free0 (current_value);
					}
					_g_object_unref0 (_current_value_it);
				}
				_g_object_unref0 (values);
				hierarchical_keyword_field_destroy (&field);
			}
		}
	}
	result = h_keywords;
	return result;
}


gboolean photo_metadata_has_orientation (PhotoMetadata* self) {
	gboolean result = FALSE;
	GExiv2Orientation _tmp0_;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
	_tmp0_ = gexiv2_metadata_get_orientation (self->priv->exiv2);
	result = _tmp0_ == GEXIV2_ORIENTATION_UNSPECIFIED;
	return result;
}


Orientation photo_metadata_get_orientation (PhotoMetadata* self) {
	Orientation result = 0;
	GExiv2Orientation _tmp0_;
	GExiv2Orientation orientation;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), 0);
	_tmp0_ = gexiv2_metadata_get_orientation (self->priv->exiv2);
	orientation = _tmp0_;
	if (orientation == GEXIV2_ORIENTATION_UNSPECIFIED) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = orientation < ORIENTATION_MIN;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = orientation > ORIENTATION_MAX;
	}
	if (_tmp1_) {
		result = ORIENTATION_TOP_LEFT;
		return result;
	} else {
		result = (Orientation) orientation;
		return result;
	}
}


void photo_metadata_set_orientation (PhotoMetadata* self, Orientation orientation) {
	g_return_if_fail (IS_PHOTO_METADATA (self));
	gexiv2_metadata_set_orientation (self->priv->exiv2, (GExiv2Orientation) orientation);
}


gboolean photo_metadata_get_gps (PhotoMetadata* self, gdouble* longitude, gchar** long_ref, gdouble* latitude, gchar** lat_ref, gdouble* altitude) {
	gdouble _longitude = 0.0;
	gchar* _long_ref = NULL;
	gdouble _latitude = 0.0;
	gchar* _lat_ref = NULL;
	gdouble _altitude = 0.0;
	gboolean result = FALSE;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gboolean _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
	_tmp3_ = gexiv2_metadata_get_gps_info (self->priv->exiv2, &_tmp0_, &_tmp1_, &_tmp2_);
	_longitude = _tmp0_;
	_latitude = _tmp1_;
	_altitude = _tmp2_;
	if (!_tmp3_) {
		result = FALSE;
		if (longitude) {
			*longitude = _longitude;
		}
		if (long_ref) {
			*long_ref = _long_ref;
		} else {
			_g_free0 (_long_ref);
		}
		if (latitude) {
			*latitude = _latitude;
		}
		if (lat_ref) {
			*lat_ref = _lat_ref;
		} else {
			_g_free0 (_lat_ref);
		}
		if (altitude) {
			*altitude = _altitude;
		}
		return result;
	}
	_tmp4_ = photo_metadata_get_string (self, "Exif.GPSInfo.GPSLongitudeRef");
	_g_free0 (_long_ref);
	_long_ref = _tmp4_;
	_tmp5_ = photo_metadata_get_string (self, "Exif.GPSInfo.GPSLatitudeRef");
	_g_free0 (_lat_ref);
	_lat_ref = _tmp5_;
	result = TRUE;
	if (longitude) {
		*longitude = _longitude;
	}
	if (long_ref) {
		*long_ref = _long_ref;
	} else {
		_g_free0 (_long_ref);
	}
	if (latitude) {
		*latitude = _latitude;
	}
	if (lat_ref) {
		*lat_ref = _lat_ref;
	} else {
		_g_free0 (_lat_ref);
	}
	if (altitude) {
		*altitude = _altitude;
	}
	return result;
}


gboolean photo_metadata_get_exposure (PhotoMetadata* self, MetadataRational* exposure) {
	MetadataRational _exposure = {0};
	gboolean result = FALSE;
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.ExposureTime", &_tmp0_);
	_exposure = _tmp0_;
	result = _tmp1_;
	if (exposure) {
		*exposure = _exposure;
	}
	return result;
}


gchar* photo_metadata_get_exposure_string (PhotoMetadata* self) {
	gchar* result = NULL;
	MetadataRational exposure_time = {0};
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_;
	gboolean _tmp2_;
	gchar* _tmp3_ = NULL;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.ExposureTime", &_tmp0_);
	exposure_time = _tmp0_;
	if (!_tmp1_) {
		result = NULL;
		return result;
	}
	_tmp2_ = metadata_rational_is_valid (&exposure_time);
	if (!_tmp2_) {
		result = NULL;
		return result;
	}
	_tmp3_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.ExposureTime");
	result = _tmp3_;
	return result;
}


gboolean photo_metadata_get_iso (PhotoMetadata* self, glong* iso) {
	glong _iso = 0L;
	gboolean result = FALSE;
	glong _tmp0_;
	gboolean _tmp1_;
	gboolean fetched_ok;
	gboolean _tmp2_ = FALSE;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
	_tmp1_ = photo_metadata_get_long (self, "Exif.Photo.ISOSpeedRatings", &_tmp0_);
	_iso = _tmp0_;
	fetched_ok = _tmp1_;
	if (fetched_ok == FALSE) {
		result = FALSE;
		if (iso) {
			*iso = _iso;
		}
		return result;
	}
	if (_iso < 6) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = _iso > 409600;
	}
	if (_tmp2_) {
		result = FALSE;
		if (iso) {
			*iso = _iso;
		}
		return result;
	}
	result = TRUE;
	if (iso) {
		*iso = _iso;
	}
	return result;
}


gchar* photo_metadata_get_iso_string (PhotoMetadata* self) {
	gchar* result = NULL;
	glong iso = 0L;
	glong _tmp0_;
	gboolean _tmp1_;
	gchar* _tmp2_ = NULL;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	_tmp1_ = photo_metadata_get_iso (self, &_tmp0_);
	iso = _tmp0_;
	if (!_tmp1_) {
		result = NULL;
		return result;
	}
	_tmp2_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.ISOSpeedRatings");
	result = _tmp2_;
	return result;
}


gboolean photo_metadata_get_aperture (PhotoMetadata* self, MetadataRational* aperture) {
	MetadataRational _aperture = {0};
	gboolean result = FALSE;
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.FNumber", &_tmp0_);
	_aperture = _tmp0_;
	result = _tmp1_;
	if (aperture) {
		*aperture = _aperture;
	}
	return result;
}


gchar* photo_metadata_get_aperture_string (PhotoMetadata* self, gboolean pango_formatted) {
	gchar* result = NULL;
	MetadataRational aperture = {0};
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_;
	gdouble aperture_value;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	_tmp1_ = photo_metadata_get_aperture (self, &_tmp0_);
	aperture = _tmp0_;
	if (!_tmp1_) {
		result = NULL;
		return result;
	}
	aperture_value = ((gdouble) aperture.numerator) / ((gdouble) aperture.denominator);
	aperture_value = ((gint) (aperture_value * 10.0)) / 10.0;
	if (pango_formatted) {
		_tmp2_ = "<i>f</i>/";
	} else {
		_tmp2_ = "f/";
	}
	if (fmod (aperture_value, 1) == 0) {
		_tmp3_ = "%.0f";
	} else {
		_tmp3_ = "%.1f";
	}
	_tmp4_ = g_strdup_printf (_tmp3_, aperture_value);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strconcat (_tmp2_, _tmp5_, NULL);
	_tmp7_ = _tmp6_;
	_g_free0 (_tmp5_);
	result = _tmp7_;
	return result;
}


gchar* photo_metadata_get_camera_make (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Make");
	result = _tmp0_;
	return result;
}


gchar* photo_metadata_get_camera_model (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Model");
	result = _tmp0_;
	return result;
}


gboolean photo_metadata_get_flash (PhotoMetadata* self, glong* flash) {
	glong _flash = 0L;
	gboolean result = FALSE;
	glong _tmp0_;
	gboolean _tmp1_;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
	_tmp1_ = photo_metadata_get_long (self, "Exif.Photo.Flash", &_tmp0_);
	_flash = _tmp0_;
	result = _tmp1_;
	if (flash) {
		*flash = _flash;
	}
	return result;
}


gchar* photo_metadata_get_flash_string (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.Flash");
	result = _tmp0_;
	return result;
}


gboolean photo_metadata_get_focal_length (PhotoMetadata* self, MetadataRational* focal_length) {
	MetadataRational _focal_length = {0};
	gboolean result = FALSE;
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.FocalLength", &_tmp0_);
	_focal_length = _tmp0_;
	result = _tmp1_;
	if (focal_length) {
		*focal_length = _focal_length;
	}
	return result;
}


gchar* photo_metadata_get_focal_length_string (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.FocalLength");
	result = _tmp0_;
	return result;
}


gchar* photo_metadata_get_artist (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	_tmp0_ = photo_metadata_get_first_string_interpreted (self, photo_metadata_ARTIST_TAGS, photo_metadata_ARTIST_TAGS_length1);
	result = _tmp0_;
	return result;
}


gchar* photo_metadata_get_copyright (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Copyright");
	result = _tmp0_;
	return result;
}


gchar* photo_metadata_get_software (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Software");
	result = _tmp0_;
	return result;
}


void photo_metadata_set_software (PhotoMetadata* self, const gchar* software, const gchar* version) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (IS_PHOTO_METADATA (self));
	g_return_if_fail (software != NULL);
	g_return_if_fail (version != NULL);
	_tmp0_ = g_strdup_printf ("%s %s", software, version);
	_tmp1_ = _tmp0_;
	photo_metadata_set_string (self, "Exif.Image.Software", _tmp1_);
	_g_free0 (_tmp1_);
	_tmp2_ = photo_metadata_has_iptc (self);
	if (_tmp2_) {
		photo_metadata_set_string (self, "Iptc.Application2.Program", software);
		photo_metadata_set_string (self, "Iptc.Application2.ProgramVersion", version);
	}
}


void photo_metadata_remove_software (PhotoMetadata* self) {
	g_return_if_fail (IS_PHOTO_METADATA (self));
	photo_metadata_remove_tag (self, "Exif.Image.Software");
	photo_metadata_remove_tag (self, "Iptc.Application2.Program");
	photo_metadata_remove_tag (self, "Iptc.Application2.ProgramVersion");
}


gchar* photo_metadata_get_exposure_bias (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.ExposureBiasValue");
	result = _tmp0_;
	return result;
}


Rating photo_metadata_get_rating (PhotoMetadata* self) {
	Rating result = 0;
	gchar* _tmp0_ = NULL;
	gchar* rating_string;
	Rating _tmp1_ = 0;
	g_return_val_if_fail (IS_PHOTO_METADATA (self), 0);
	_tmp0_ = photo_metadata_get_first_string (self, photo_metadata_RATING_TAGS, photo_metadata_RATING_TAGS_length1);
	rating_string = _tmp0_;
	if (rating_string == NULL) {
		_tmp1_ = RATING_UNRATED;
	} else {
		gint _tmp2_;
		Rating _tmp3_;
		_tmp2_ = atoi (rating_string);
		_tmp3_ = rating_unserialize (_tmp2_);
		_tmp1_ = _tmp3_;
	}
	result = _tmp1_;
	_g_free0 (rating_string);
	return result;
}


void photo_metadata_set_rating (PhotoMetadata* self, Rating rating) {
	gint _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	g_return_if_fail (IS_PHOTO_METADATA (self));
	_tmp0_ = rating_serialize (rating);
	_tmp1_ = g_strdup_printf ("%i", _tmp0_);
	_tmp2_ = _tmp1_;
	photo_metadata_set_string (self, "Xmp.xmp.Rating", _tmp2_);
	_g_free0 (_tmp2_);
}


static gpointer _media_metadata_ref0 (gpointer self) {
	return self ? media_metadata_ref (self) : NULL;
}


static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_construct (GType object_type, PhotoMetadata* owner, const gchar* name, guint number, GExiv2PreviewProperties* props) {
	PhotoMetadataInternalPhotoPreview* self = NULL;
	guint32 _tmp0_;
	guint32 _tmp1_;
	Dimensions _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
	guint32 _tmp4_;
	const gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	PhotoMetadata* _tmp7_;
	g_return_val_if_fail (IS_PHOTO_METADATA (owner), NULL);
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (props != NULL, NULL);
	_tmp0_ = gexiv2_preview_properties_get_width (props);
	_tmp1_ = gexiv2_preview_properties_get_height (props);
	dimensions_init (&_tmp2_, (gint) _tmp0_, (gint) _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = gexiv2_preview_properties_get_size (props);
	_tmp5_ = gexiv2_preview_properties_get_mime_type (props);
	_tmp6_ = gexiv2_preview_properties_get_extension (props);
	self = (PhotoMetadataInternalPhotoPreview*) photo_preview_construct (object_type, name, &_tmp3_, _tmp4_, _tmp5_, _tmp6_);
	_tmp7_ = _media_metadata_ref0 (owner);
	_media_metadata_unref0 (self->owner);
	self->owner = _tmp7_;
	self->number = number;
	return self;
}


static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_new (PhotoMetadata* owner, const gchar* name, guint number, GExiv2PreviewProperties* props) {
	return photo_metadata_internal_photo_preview_construct (PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, owner, name, number, props);
}


static guint8* _vala_array_dup10 (guint8* self, int length) {
	return g_memdup (self, length * sizeof (guint8));
}


static guint8* photo_metadata_internal_photo_preview_real_flatten (PhotoPreview* base, int* result_length1, GError** error) {
	PhotoMetadataInternalPhotoPreview * self;
	guint8* result = NULL;
	GExiv2PreviewProperties** _tmp0_;
	GExiv2PreviewProperties** _tmp1_ = NULL;
	GExiv2PreviewProperties** props;
	gint props_length1;
	gint _props_size_;
	gboolean _tmp2_ = FALSE;
	GExiv2PreviewImage* _tmp3_ = NULL;
	GExiv2PreviewImage* _tmp4_;
	gint _tmp5_;
	guchar** _tmp6_ = NULL;
	guint8* _tmp7_;
	guint8* _tmp8_;
	guint8* _tmp9_;
	guchar** _tmp10_;
	self = PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW (base);
	_tmp1_ = _tmp0_ = gexiv2_metadata_get_preview_properties (self->owner->priv->exiv2);
	props = _tmp1_;
	props_length1 = _vala_array_length (_tmp0_);
	_props_size_ = _vala_array_length (_tmp0_);
	if (props != NULL) {
		_tmp2_ = props_length1 > self->number;
	} else {
		_tmp2_ = FALSE;
	}
	g_assert (_tmp2_);
	_tmp3_ = gexiv2_metadata_get_preview_image (self->owner->priv->exiv2, props[self->number]);
	_tmp4_ = _tmp3_;
	_tmp6_ = gexiv2_preview_image_get_data (_tmp4_, &_tmp5_);
	_tmp7_ = (_tmp8_ = _tmp6_, (_tmp8_ == NULL) ? ((gpointer) _tmp8_) : _vala_array_dup10 (_tmp8_, _tmp5_));
	_tmp9_ = _tmp7_;
	_gexiv2_preview_image_free0 (_tmp4_);
	_tmp10_ = _tmp9_;
	*result_length1 = _tmp5_;
	result = _tmp10_;
	return result;
}


static void photo_metadata_internal_photo_preview_class_init (PhotoMetadataInternalPhotoPreviewClass * klass) {
	photo_metadata_internal_photo_preview_parent_class = g_type_class_peek_parent (klass);
	PHOTO_PREVIEW_CLASS (klass)->finalize = photo_metadata_internal_photo_preview_finalize;
	PHOTO_PREVIEW_CLASS (klass)->flatten = photo_metadata_internal_photo_preview_real_flatten;
}


static void photo_metadata_internal_photo_preview_instance_init (PhotoMetadataInternalPhotoPreview * self) {
}


static void photo_metadata_internal_photo_preview_finalize (PhotoPreview* obj) {
	PhotoMetadataInternalPhotoPreview * self;
	self = PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW (obj);
	_media_metadata_unref0 (self->owner);
	PHOTO_PREVIEW_CLASS (photo_metadata_internal_photo_preview_parent_class)->finalize (obj);
}


static GType photo_metadata_internal_photo_preview_get_type (void) {
	static volatile gsize photo_metadata_internal_photo_preview_type_id__volatile = 0;
	if (g_once_init_enter (&photo_metadata_internal_photo_preview_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoMetadataInternalPhotoPreviewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_metadata_internal_photo_preview_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoMetadataInternalPhotoPreview), 0, (GInstanceInitFunc) photo_metadata_internal_photo_preview_instance_init, NULL };
		GType photo_metadata_internal_photo_preview_type_id;
		photo_metadata_internal_photo_preview_type_id = g_type_register_static (TYPE_PHOTO_PREVIEW, "PhotoMetadataInternalPhotoPreview", &g_define_type_info, 0);
		g_once_init_leave (&photo_metadata_internal_photo_preview_type_id__volatile, photo_metadata_internal_photo_preview_type_id);
	}
	return photo_metadata_internal_photo_preview_type_id__volatile;
}


static void photo_metadata_class_init (PhotoMetadataClass * klass) {
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar** _tmp3_ = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar** _tmp10_ = NULL;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar** _tmp13_ = NULL;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar** _tmp18_ = NULL;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar** _tmp23_ = NULL;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar** _tmp28_ = NULL;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar** _tmp31_ = NULL;
	HierarchicalKeywordField _tmp32_ = {0};
	HierarchicalKeywordField _tmp33_ = {0};
	HierarchicalKeywordField _tmp34_ = {0};
	HierarchicalKeywordField _tmp35_ = {0};
	HierarchicalKeywordField _tmp36_ = {0};
	HierarchicalKeywordField _tmp37_ = {0};
	HierarchicalKeywordField* _tmp38_ = NULL;
	gchar* _tmp39_;
	gchar* _tmp40_;
	gchar** _tmp41_ = NULL;
	gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar** _tmp45_ = NULL;
	photo_metadata_parent_class = g_type_class_peek_parent (klass);
	MEDIA_METADATA_CLASS (klass)->finalize = photo_metadata_finalize;
	g_type_class_add_private (klass, sizeof (PhotoMetadataPrivate));
	MEDIA_METADATA_CLASS (klass)->read_from_file = photo_metadata_real_read_from_file;
	MEDIA_METADATA_CLASS (klass)->get_creation_date_time = photo_metadata_real_get_creation_date_time;
	MEDIA_METADATA_CLASS (klass)->get_title = photo_metadata_real_get_title;
	_tmp0_ = g_strdup ("Exif.Image.DateTime");
	_tmp1_ = g_strdup ("Xmp.tiff.DateTime");
	_tmp2_ = g_strdup ("Xmp.xmp.ModifyDate");
	_tmp3_ = g_new0 (gchar*, 3 + 1);
	_tmp3_[0] = _tmp0_;
	_tmp3_[1] = _tmp1_;
	_tmp3_[2] = _tmp2_;
	photo_metadata_DATE_TIME_TAGS = _tmp3_;
	photo_metadata_DATE_TIME_TAGS_length1 = 3;
	_tmp4_ = g_strdup ("Exif.Photo.DateTimeOriginal");
	_tmp5_ = g_strdup ("Xmp.exif.DateTimeOriginal");
	_tmp6_ = g_strdup ("Xmp.xmp.CreateDate");
	_tmp7_ = g_strdup ("Exif.Photo.DateTimeDigitized");
	_tmp8_ = g_strdup ("Xmp.exif.DateTimeDigitized");
	_tmp9_ = g_strdup ("Exif.Image.DateTime");
	_tmp10_ = g_new0 (gchar*, 6 + 1);
	_tmp10_[0] = _tmp4_;
	_tmp10_[1] = _tmp5_;
	_tmp10_[2] = _tmp6_;
	_tmp10_[3] = _tmp7_;
	_tmp10_[4] = _tmp8_;
	_tmp10_[5] = _tmp9_;
	photo_metadata_EXPOSURE_DATE_TIME_TAGS = _tmp10_;
	photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1 = 6;
	_tmp11_ = g_strdup ("Exif.Photo.DateTimeDigitized");
	_tmp12_ = g_strdup ("Xmp.exif.DateTimeDigitized");
	_tmp13_ = g_new0 (gchar*, 2 + 1);
	_tmp13_[0] = _tmp11_;
	_tmp13_[1] = _tmp12_;
	photo_metadata_DIGITIZED_DATE_TIME_TAGS = _tmp13_;
	photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1 = 2;
	_tmp14_ = g_strdup ("Exif.Photo.PixelXDimension");
	_tmp15_ = g_strdup ("Xmp.exif.PixelXDimension");
	_tmp16_ = g_strdup ("Xmp.tiff.ImageWidth");
	_tmp17_ = g_strdup ("Xmp.exif.PixelXDimension");
	_tmp18_ = g_new0 (gchar*, 4 + 1);
	_tmp18_[0] = _tmp14_;
	_tmp18_[1] = _tmp15_;
	_tmp18_[2] = _tmp16_;
	_tmp18_[3] = _tmp17_;
	photo_metadata_WIDTH_TAGS = _tmp18_;
	photo_metadata_WIDTH_TAGS_length1 = 4;
	_tmp19_ = g_strdup ("Exif.Photo.PixelYDimension");
	_tmp20_ = g_strdup ("Xmp.exif.PixelYDimension");
	_tmp21_ = g_strdup ("Xmp.tiff.ImageHeight");
	_tmp22_ = g_strdup ("Xmp.exif.PixelYDimension");
	_tmp23_ = g_new0 (gchar*, 4 + 1);
	_tmp23_[0] = _tmp19_;
	_tmp23_[1] = _tmp20_;
	_tmp23_[2] = _tmp21_;
	_tmp23_[3] = _tmp22_;
	photo_metadata_HEIGHT_TAGS = _tmp23_;
	photo_metadata_HEIGHT_TAGS_length1 = 4;
	_tmp24_ = g_strdup ("Iptc.Application2.Caption");
	_tmp25_ = g_strdup ("Xmp.dc.title");
	_tmp26_ = g_strdup ("Iptc.Application2.Headline");
	_tmp27_ = g_strdup ("Xmp.photoshop.Headline");
	_tmp28_ = g_new0 (gchar*, 4 + 1);
	_tmp28_[0] = _tmp24_;
	_tmp28_[1] = _tmp25_;
	_tmp28_[2] = _tmp26_;
	_tmp28_[3] = _tmp27_;
	photo_metadata_STANDARD_TITLE_TAGS = _tmp28_;
	photo_metadata_STANDARD_TITLE_TAGS_length1 = 4;
	_tmp29_ = g_strdup ("Xmp.dc.subject");
	_tmp30_ = g_strdup ("Iptc.Application2.Keywords");
	_tmp31_ = g_new0 (gchar*, 2 + 1);
	_tmp31_[0] = _tmp29_;
	_tmp31_[1] = _tmp30_;
	photo_metadata_KEYWORD_TAGS = _tmp31_;
	photo_metadata_KEYWORD_TAGS_length1 = 2;
	hierarchical_keyword_field_init (&_tmp32_, "Xmp.lr.hierarchicalSubject", "|", FALSE, FALSE);
	_tmp33_ = _tmp32_;
	hierarchical_keyword_field_init (&_tmp34_, "Xmp.digiKam.TagsList", "/", FALSE, TRUE);
	_tmp35_ = _tmp34_;
	hierarchical_keyword_field_init (&_tmp36_, "Xmp.MicrosoftPhoto.LastKeywordXMP", "/", FALSE, TRUE);
	_tmp37_ = _tmp36_;
	_tmp38_ = g_new0 (HierarchicalKeywordField, 3);
	_tmp38_[0] = _tmp33_;
	_tmp38_[1] = _tmp35_;
	_tmp38_[2] = _tmp37_;
	photo_metadata_HIERARCHICAL_KEYWORD_TAGS = _tmp38_;
	photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1 = 3;
	_tmp39_ = g_strdup ("Exif.Image.Artist");
	_tmp40_ = g_strdup ("Exif.Canon.OwnerName");
	_tmp41_ = g_new0 (gchar*, 2 + 1);
	_tmp41_[0] = _tmp39_;
	_tmp41_[1] = _tmp40_;
	photo_metadata_ARTIST_TAGS = _tmp41_;
	photo_metadata_ARTIST_TAGS_length1 = 2;
	_tmp42_ = g_strdup ("Xmp.xmp.Rating");
	_tmp43_ = g_strdup ("Iptc.Application2.Urgency");
	_tmp44_ = g_strdup ("Xmp.photoshop.Urgency");
	_tmp45_ = g_new0 (gchar*, 3 + 1);
	_tmp45_[0] = _tmp42_;
	_tmp45_[1] = _tmp43_;
	_tmp45_[2] = _tmp44_;
	photo_metadata_RATING_TAGS = _tmp45_;
	photo_metadata_RATING_TAGS_length1 = 3;
}


static void photo_metadata_instance_init (PhotoMetadata * self) {
	GExiv2Metadata* _tmp0_ = NULL;
	gchar* _tmp1_;
	self->priv = PHOTO_METADATA_GET_PRIVATE (self);
	_tmp0_ = gexiv2_metadata_new ();
	self->priv->exiv2 = _tmp0_;
	self->priv->exif = NULL;
	_tmp1_ = g_strdup ("<uninitialized>");
	self->priv->source_name = _tmp1_;
}


static void photo_metadata_finalize (MediaMetadata* obj) {
	PhotoMetadata * self;
	self = PHOTO_METADATA (obj);
	_gexiv2_metadata_free0 (self->priv->exiv2);
	_exif_data_unref0 (self->priv->exif);
	_g_free0 (self->priv->source_name);
	MEDIA_METADATA_CLASS (photo_metadata_parent_class)->finalize (obj);
}


GType photo_metadata_get_type (void) {
	static volatile gsize photo_metadata_type_id__volatile = 0;
	if (g_once_init_enter (&photo_metadata_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoMetadataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_metadata_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoMetadata), 0, (GInstanceInitFunc) photo_metadata_instance_init, NULL };
		GType photo_metadata_type_id;
		photo_metadata_type_id = g_type_register_static (TYPE_MEDIA_METADATA, "PhotoMetadata", &g_define_type_info, 0);
		g_once_init_leave (&photo_metadata_type_id__volatile, photo_metadata_type_id);
	}
	return photo_metadata_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



